#Feb 14'19 
#Author : Zeynep G. Saribatur
 
from __future__ import division
import sys
import os, glob
import subprocess
import time
import re
import random
from random import randint
from collections import Counter
import itertools
import csv
from shutil import copyfile
import time

			
def createCheckFile(sets,logFile):

	arr=[]
	for i in range(0,len(sets)):
		checkfile=open(test+ '_check_answer'+str(i), 'w')
		logFile.write("In file "+ test+ "_check_answer"+str(i)+": "+ "\n")
		checkfile.write("%"+ sets[i])
		logFile.write("%"+ sets[i])
		arr=sets[i].split(', ')
		checkfile.write("\n")
		logFile.write("\n")
		for j in range(0, len(arr)):
			if arr[j].find("mapTo")==-1 and arr[j].find("_")!=0 and arr[j]!="":
				checkfile.write("absexists("+ arr[j] + "). ")
				logFile.write("absexists("+ arr[j] + "). ")
		checkfile.close()	
		logFile.write("\n")

	logFile.write("\n Step4 is done." + "\n")		
	logFile.write("\n")
	
def testIfIndeedHasSolution(test,logFile):
	clingo = subprocess.Popen(
			"clingo {} ".format(test + ' reltype_computation/aux_nonbinaryrelations.lp'),
			 shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
	clingoout, clingoerr = clingo.communicate()
	clingo.wait()
	del clingo
	clingoout = clingoout.decode('utf-8')
	if clingoout.find('UNSATISFIABLE') != -1:
		print("PROGRAM IS ACTUALLY UNSAT")
		logFile.write("PROGRAM IS ACTUALLY UNSAT\n")
		sys.exit()
		
def callClingoForDebugging(i,outputFile,temp,test,mapping,logFile):
	global mainlog
	global writer
	global index

	logFile.write("Clingo is called with: "+ outputFile+' '+temp+'_checkrules'+' '+test+ '_check_answer'+str(i)+ ' '+mapping+ " reltype_computation/aux_nonbinaryrelations.lp aux_absregionfacts.lp --time-limit=20\n")
	t=time.clock()
	clingo = subprocess.Popen(
		"clingo {} ".format(outputFile+' '+temp+'_checkrules'+' '+test+ '_check_answer'+str(i)+ ' '+mapping+' reltype_computation/aux_nonbinaryrelations.lp aux_absregionfacts.lp --time-limit=20'),
		 shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
	clingoout, clingoerr = clingo.communicate()
	clingo.wait()
	del clingo
	clingoout = clingoout.decode('utf-8')
	
	elapsed_time = time.clock() - t
	print(elapsed_time)

	mainlog+="checking at original domain\n"
	mainlog+="time for checking an abstract answer sets: "+str(elapsed_time)+"\n"
        mainlog+=clingoout[clingoout.find("CPU Time"):]
	writer[index].append(re.findall(r"CPU Time\ +: (\S*)s",clingoout)[0])
	clingoLines=clingoout.split("\n")

	for k in range (0, len(clingoLines)):
		if clingoLines[k].find("UNSATISFIABLE")!= -1:
			print("ANSWER IS UNSATISFIABLE, quitting...")
			sys.exit()
		if clingoLines[k].find("OPTIMUM FOUND")!= -1 or clingoLines[k].find("SATISFIABLE")!= -1:
			break
		
	if k==len(clingoLines)-1:
		print("No OPTIMUM FOUND, quitting...")
		sys.exit()
	
	if "ab" not in clingoLines[k-2]:
		print("DONE! Found a solution to "+ test)
		logFile.write("DONE! Found a solution to "+ test+"\n\n")
		cost=0
		print("testing the original program!")
		#if the org prog is actually unsat -> exits
		testIfIndeedHasSolution(test,logFile)
		return []
	else:
		abtext=clingoLines[k-2]
		return abtext
    
def isIncLevelRefToCurrentAbsDom(inclevel):
    for reg in absdom:
        for increg in inclevel:
            if reg[0]!=increg[0] and reg[0] in increg[0] and reg[1]!=increg[1] and reg[1] in increg[1]:
                return False            
    return True

def pickIncLevelRefToCurrentAbsDom(inclevellist,checkedincs):
	possinclevels=[]
	for inclevel in inclevellist:
		badinclevel=False
		foundequal=False
		equals=0
		for reg in absdom:
			for increg in inclevel:
          			if reg[0]!=increg[0] and reg[0] in increg[0] and reg[1]!=increg[1] and reg[1] in increg[1]:
					badinclevel=True
					break
				elif reg[0]==increg[0] and reg[1]==increg[1]:
					equals+=1
					foundequal=True
					break
			if badinclevel==True:
				break
    		if badinclevel!=True and inclevellist.index(inclevel)+1 not in checkedincs:
			possinclevels.append([inclevel,equals])
	if possinclevels!=[]:
		possinclevels.sort(key=lambda x: x[1],reverse=True)
		print possinclevels
		possincsmallestequals=[p for p in possinclevels if p[1]==possinclevels[0][1]]
		print "have "+str(len(possincsmallestequals))+" possible inc levels - picking one random"
		return random.sample(possincsmallestequals,1)[0][0]
	else:
		return -1

def incrementalDebugOverGrid(i,temp,test,logFile,prevlevel):
    global mainlog
    global writer
    global index
    global checkedincs

    fin=open(temp+'_absfacts',"r")
    text=fin.read()
    fin.close()
    tempinc=temp[:temp.rfind("/")+1]+"incremental/"+temp[temp.rfind("/")+1:]
    incfolder=temp[:temp.rfind("/")+1]+"incremental/"
    fout=open(tempinc+'_absfacts_org2inc',"w")
    fout.write(text.replace("mapTo","mapOrgToInc"))
    fout.close()
    
    mainchildren=[("".join(["a"+str(a) for a in range(1,int(size/2)+1)]),"".join(["b"+str(a) for a in range(1,int(size/2)+1)]))]
    mainchildren+=[("".join(["a"+str(a) for a in range(1,int(size/2)+1)]),"".join(["b"+str(a) for a in range(int(size/2)+1,size+1)]))]
    mainchildren+=[("".join(["a"+str(a) for a in range(int(size/2)+1,size+1)]),"".join(["b"+str(a) for a in range(1,int(size/2)+1)]))]
    mainchildren+=[("".join(["a"+str(a) for a in range(int(size/2)+1,size+1)]),"".join(["b"+str(a) for a in range(int(size/2)+1,size+1)]))]
    #print mainchildren  #1
    firstinc=refineRegionToOrg(mainchildren[0])[0]+mainchildren[1:]
    #print firstinc      #2
    secondinc=refineRegionToOrg(mainchildren[0])[0]+refineRegionToOrg(mainchildren[1])[0]+mainchildren[2:]
    #print secondinc     #3
    thirdinc=refineRegionToOrg(mainchildren[0])[0]+refineRegionToOrg(mainchildren[1])[0]+refineRegionToOrg(mainchildren[2])[0]+mainchildren[3:]
    #print thirdinc      #4
    firstincA=mainchildren[:1]+refineRegionToOrg(mainchildren[1])[0]+mainchildren[2:]
    #print firstinc      #5
    secondincA=mainchildren[:1]+refineRegionToOrg(mainchildren[1])[0]+[mainchildren[2]]+refineRegionToOrg(mainchildren[3])[0]
    #print secondinc     #6
    thirdincA=mainchildren[:1]+refineRegionToOrg(mainchildren[1])[0]+refineRegionToOrg(mainchildren[2])[0]+refineRegionToOrg(mainchildren[3])[0]
    #print thirdinc      #7
    firstincB=mainchildren[:2]+refineRegionToOrg(mainchildren[2])[0]+mainchildren[3:]
    #print firstinc      #8
    secondincB=mainchildren[:2]+refineRegionToOrg(mainchildren[2])[0]+refineRegionToOrg(mainchildren[3])[0]
    #print secondinc     #9
    firstincC=mainchildren[:3]+refineRegionToOrg(mainchildren[3])[0]
    #print secondinc     #10
    secondincC=refineRegionToOrg(mainchildren[0])[0]+[mainchildren[1]]+refineRegionToOrg(mainchildren[2])[0]+refineRegionToOrg(mainchildren[3])[0]
    #print secondinc     #11
    thirdincC=refineRegionToOrg(mainchildren[0])[0]+refineRegionToOrg(mainchildren[1])[0]+[mainchildren[2]]+refineRegionToOrg(mainchildren[3])[0]
    alllist=[firstinc,secondinc,thirdinc,firstincA,secondincA,thirdincA,firstincB,secondincB,firstincC,secondincC,thirdincC]

    while True:  
	pickedlevel=pickIncLevelRefToCurrentAbsDom(alllist,checkedincs)
	if pickedlevel==-1:
		print "NEED to check at the original level!"
		return [False,12]
	else:
		level=alllist.index(pickedlevel)+1
		print("at incremental refine level "+str(level))
            	inc=True  
            	mappingorgtoinc="generated_mappings/incremental/mapping_orgToInc"+str(level)+"_size"+str(size)+".lp"
		createMappingFile(pickedlevel,mappingorgtoinc,pred,cellmapping,inc)
		inc=False
		mappingorgtoincforreltype="generated_mappings/incremental/mapping_orgToInc"+str(level)+"_size"+str(size)+"_forRelTypeComp.lp"
		createMappingFile(pickedlevel,mappingorgtoincforreltype,pred,cellmapping,inc)        
		mappinginctoabs="generated_mappings/incremental/mapping_inc"+str(level)+"ToAbs.lp"
		createIncMappingFile(absdom,pickedlevel,mappinginctoabs,pred)
		
        
     
        newabsregfactname=incfolder+"aux_absregionfacts_inc"+str(level)+"_size"+str(size)+".lp"      
        newabsreltypename=incfolder+"aux_reltypefacts_inc"+str(level)+"_size"+str(size)+".lp"
        if level!=prevlevel and (not os.path.isfile(newabsregfactname) or not os.path.isfile(temp+"_abs_objname_input")):
            logFile.write("Running program_dom_abstraction_abstract_relations.py "+ temp+"_abs_objname "+ mappingorgtoincforreltype +" "+pred+" --metaobj=True\n")

            p= subprocess.Popen("python program_dom_abstraction_abstract_relations.py  "+ temp+"_abs_objname "+ mappingorgtoincforreltype +" "+pred+" --metaobj=True",shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
            output, err =p.communicate()
            p.wait()
            
            os.rename(temp+"_abs_objname_input_meta",tempinc+"_abs_objname_input_meta")
            # Feb 6'19 - if reltypecomputation was already done, then prev call will not create checkrules file etc. 
            if os.path.isfile(temp+"_checkrules"):
                copyfile(temp+"_checkrules",tempinc+"_checkrules")
            if not os.path.isfile(newabsregfactname):
                os.rename("aux_absregionfacts_inc.lp",newabsregfactname)
                os.rename("aux_reltypefacts.lp",newabsreltypename)



	logFile.write("Running translatorMetaToNonGroundSpock_withoutArg.py " + tempinc+"_abs_objname_input_meta\n")

	p= subprocess.Popen("python translatorMetaToNonGroundSpock_withoutArg.py {} ".format(tempinc+"_abs_objname_input_meta"),shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
	output, err =p.communicate()
	p.wait()
		
	try:
		with open(tempinc+"_abs_objname_input_meta_debug") as f:
			f.close()

	except IOError:
		print(tempinc+"_abs_objname_input_meta_debug does not exist. ")
		sys.exit()

	mainlog+="debug without arguments\n"
	debugwithoutArg=True
	
      

	debugstep=0
	
	while debugstep<2:
    
		#FIXME Feb 6'19 - the weak constraints sometimes show up even if answer is concrete wrt the inc domain since they are at same abs level
		#		  so for now doing a two step check... first with onlymain then with debug ---> not adding in it out for now - there may be no need
		logFile.write("Clingo is called with: "+ tempinc+"_abs_objname_input_meta_debug "+tempinc+'_absfacts_org2inc '+tempinc+'_checkrules'+' '+test+ '_check_answer'+str(i)+ ' '+mappingorgtoinc+ " "+mappinginctoabs+" "+newabsreltypename+" aux_absregionfacts.lp "+newabsregfactname+" --time-limit=20\n")
		
		t=time.clock()
		clingo = subprocess.Popen("clingo {} ".format(tempinc+"_abs_objname_input_meta_debug "+tempinc+'_absfacts_org2inc '+tempinc+'_checkrules'+' '+test+ '_check_answer'+str(i)+ ' '+mappingorgtoinc+ " "+mappinginctoabs+" "+newabsreltypename+" aux_absregionfacts.lp "+newabsregfactname+" --time-limit=20"),shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
		clingoout, clingoerr = clingo.communicate()
		clingo.wait()
		#print(clingoout)
		del clingo
		clingoout = clingoout.decode('utf-8')
		
		
		elapsed_time = time.clock() - t
		print(elapsed_time)
		mainlog+="checking at level "+str(level)+"\n"
		mainlog+="time for checking an abstract answer sets: "+str(elapsed_time)+"\n"
		
		mainlog+=clingoout[clingoout.find("CPU Time"):]
		writer[index].append(re.findall(r"CPU Time\ +: (\S*)s",clingoout)[0])

		clingoLines=clingoout.split("\n")
		for k in range (0, len(clingoLines)):
		    if clingoLines[k].find("UNSATISFIABLE")!= -1:
		        print("ANSWER IS UNSATISFIABLE, quitting...")
		        sys.exit()
		    elif clingoLines[k].find("OPTIMUM FOUND")!= -1 or clingoLines[k].find("SATISFIABLE")!= -1:
		        break
		    
		
		if k==len(clingoLines)-1:
		    print("No OPTIMUM FOUND, quitting...")
		    sys.exit()
	    
		if "ab" not in clingoLines[k-2]:
		    print("NO AB EXISTS NEED TO INCREMENT THE GRID ABSTRACTION")
		    checkedincs.append(level)
		    spamwriter.writerow(writer[index])
		    index=index+1
		    writer[index].append("")
		    writer[index].append("")
		    writer[index].append("change inc level")
		    break
		else:
		    abtext=clingoLines[k-2]
		    if debugwithoutArg==True:
			spamwriter.writerow(writer[index])
			index=index+1
			writer[index].append("")
			writer[index].append("")
			writer[index].append("debugwithargs")
			deactivatingrules=re.findall(r"ab_deactivated[A-Za-z]*\((\S*)\)",abtext)
			activatingpreds=re.findall(r"ab_activated\(([A-Za-z0-9\_]*)",abtext)
			if activatingpreds!=[]:
				activatingpreds=list(set(activatingpreds))
			print(deactivatingrules)
			print(activatingpreds)

			logFile.write("Running translatorMetaToNonGroundSpock.py " + tempinc+"_abs_objname_input_meta "+",".join(deactivatingrules)+" "+",".join(activatingpreds)+"\n")

		        p= subprocess.Popen("python translatorMetaToNonGroundSpock.py {} ".format(tempinc+"_abs_objname_input_meta "+",".join(deactivatingrules)+" "+",".join(activatingpreds)),shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
		        output, err =p.communicate()
		        p.wait()
                    
			try:
				with open(tempinc+"_abs_objname_input_meta_debug") as f:
					f.close()

			except IOError:
				print(tempinc+"_abs_objname_input_meta_debug does not exist. ")
				sys.exit()

			debugwithoutArg=False
		    else:
			    return [abtext,level]
        

def incrementalDebugOverTime(i,outputFile,temp,test,mapping,logFile):
    global mainlog
    
    fin=open(temp+'_checkrules',"r")
    text=fin.read()
    fin.close()
    #Jan 21'19 - FIXME what if there is some irrelevant variable name that has T in it :(
    atomswithtime=re.findall(r":- absexists\((\S+)\(([A-Z0-9a-z,]*T[A-Z0-9a-z,]*)\)\)",text)
    fin=open(outputFile,"r")
    textDebug=fin.read()
    fin.close()
    fin=open(outputFile+"_onlymain","r")
    textDebugOnlyMain=fin.read()
    fin.close()
    textDebugOnlyMain=re.sub(r'([^A-Za-z])r(\d+)',r'\1tempr\2',textDebugOnlyMain)
    textDebugOnlyMain=re.sub(r'time',r'temptime',textDebugOnlyMain)
    if "timea" in textDebug:
        actiontimeseparate=True
    else:
        actiontimeseparate=False
    timepreds=re.findall(r"time\((\d*)\)",textDebug)
    fin=open(test+ '_check_answer'+str(i),"r")
    textAnswer=fin.read()
    fin.close()
    if "0" in timepreds:
        #Jan 22'19 - even if time starts with 0, actions occur in 0 and effects in 1.. so should start with 1 again..
        mintime=1
        maxtime=len(timepreds)-1
    else:
        #Jan 21'19 - would have liked to start with more time to get more ab atoms and have better hints.. if mintime=2 already takes too much time....
        mintime=1
        maxtime=len(timepreds)
    for t in range(mintime,maxtime+1):
        textDebugTemp=textDebug
        textDebugOnlyMainTemp=textDebugOnlyMain
        textAnswerTemp=textAnswer
        for t2 in timepreds:
            if int(t2)>t:
                textDebugTemp=re.sub(r'(time\('+t2+'\))',r'%\1',textDebugTemp)
                textDebugTemp=re.sub(r'(timea\('+str(int(t2)-1)+'\))',r'%\1',textDebugTemp)
                #if int(t2)>t:
                textDebugOnlyMainTemp=re.sub(r'(temptime\('+t2+'\))',r'%\1',textDebugOnlyMainTemp)
                textDebugOnlyMainTemp=re.sub(r'(temptimea\('+str(int(t2)-1)+'\))',r'%\1',textDebugOnlyMainTemp)
            elif int(t2)==t:
                textDebugOnlyMainTemp=re.sub(r'(temptime\('+t2+'\))',r'%\1',textDebugOnlyMainTemp)
                textDebugOnlyMainTemp=re.sub(r'(temptimea\('+str(int(t2)-1)+'\))',r'%\1',textDebugOnlyMainTemp)	
        #print atomswithtime
        for a in atomswithtime:
            answerpredsA=re.findall(r"(absexists\("+a[0]+"\(([A-Z0-9a-z,\-\(\)]*)\)\).)",textAnswer)		
            answerpredsD=re.findall(r"("+a[0]+"\(([0-9a-z,\-]*)\).)",textDebugTemp)
            args=a[1].split(",")
            #Jan 21'19 - FIXME what if there are args with T1,T2 and such??
            timeargindex=args.index("T")
            if actiontimeseparate==False or (a[0]!="go" and a[0]!="move"): # Jan 27'19 - need to distinguish action names better FIXME TODO
                for a2 in answerpredsA:
                    a2temp=re.sub(r"\(([A-Za-z0-9]+),([A-Za-z0-9]+)\)",r"\(\1_\2\)",a2[1])

                    if int(a2temp.split(",")[timeargindex])>t:
                        textAnswerTemp=textAnswerTemp.replace(a2[0],"\n%"+a2[0]+"\n")
            else:
                for a2 in answerpredsA:
                    a2temp=re.sub(r"\(([A-Za-z0-9]+),([A-Za-z0-9]+)\)",r"\(\1_\2\)",a2[1])
                    if int(a2temp.split(",")[timeargindex])>t-1:
                        textAnswerTemp=textAnswerTemp.replace(a2[0],"\n%"+a2[0]+"\n")
            for a2 in answerpredsD:
                if int(a2[1].split(",")[timeargindex])>t:
                    textDebugTemp=textDebugTemp.replace(a2[0],"%"+a2[0])
                    textDebugOnlyMainTemp=textDebugOnlyMainTemp.replace(a2[0],"%"+a2[0])
        fout=open(outputFile+"_incTime","w")
        fout.write(textDebugTemp)
        fout.close()
        fout=open(outputFile+"_onlyMain_incTime","w")
        fout.write(textDebugOnlyMainTemp)
        fout.close()
        fout=open(test+ '_check_answer'+str(i)+"_incTime","w")
        fout.write(textAnswerTemp)
        fout.close()
        
        
        logFile.write("Clingo is called with: "+ outputFile+'_incTime '+ outputFile+'_onlyMain_incTime '+temp+'_checkrules'+' '+test+ '_check_answer'+str(i)+ '_incTime '+mapping+ " reltype_computation/aux_nonbinaryrelations.lp aux_absregionfacts.lp --time-limit=20\n")
                
        ttt=time.clock()
        clingo = subprocess.Popen(
            "clingo {} ".format(outputFile+'_incTime '+ outputFile+'_onlyMain_incTime '+temp+'_checkrules'+' '+test+ '_check_answer'+str(i)+ '_incTime '+mapping+' reltype_computation/aux_nonbinaryrelations.lp aux_absregionfacts.lp --time-limit=20'),
            shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
        clingoout, clingoerr = clingo.communicate()
        #print(clingoout)
        clingo.wait()
        del clingo
        clingoout = clingoout.decode('utf-8')
        
        elapsed_time = time.clock() - ttt
        print(elapsed_time)
        mainlog+="checking at inctime "+str(t)+"\n"
        mainlog+="time for checking an abstract answer sets: "+str(elapsed_time)+"\n"
	mainlog+=clingoout[clingoout.find("CPU Time"):]

        clingoLines=clingoout.split("\n")
        for k in range (0, len(clingoLines)):
            if clingoLines[k].find("UNSATISFIABLE")!= -1:
                print("ANSWER IS UNSATISFIABLE, quitting...")
                sys.exit()
            if clingoLines[k].find("OPTIMUM FOUND")!= -1 or clingoLines[k].find("SATISFIABLE")!= -1:
                break
                
        if k==len(clingoLines)-1:
            print("No OPTIMUM FOUND, quitting...")
            sys.exit()
        
        if "ab" not in clingoLines[k-2]:
            if t!=maxtime:
                print("incremental check until time="+ str(t)+" is ok, will increment it more (or leave if it is max)")
                logFile.write("incremental check until time="+ str(t)+" is ok\n")
            else:    
                print("DONE! Found a solution to "+ test)
                logFile.write("DONE! Found a solution to "+ test+"\n\n")
                cost=0
                print("testing the original program!")
                #if the org prog is actually unsat -> exits
                testIfIndeedHasSolution(test,logFile)
                return []
        else:
            abtext=clingoLines[k-2]
            print("Clingo is called with: "+ outputFile+'_incTime '+ outputFile+'_onlyMain_incTime '+temp+'_checkrules'+' '+test+ '_check_answer'+str(i)+ '_incTime '+mapping+ " reltype_computation/aux_nonbinaryrelations.lp aux_absregionfacts.lp\n")
            print("returning from incremental search at time="+str(t))
            return abtext
            

def debugAnswerToGetCost(test,temp,mapping,onlyanswersets,logFile,refType,incremental):
	global alloccurringabatoms
	global mainlog
	global writer
	global index
	global level
    
	cost=[]
	mincost=-1
	abtext=""
	for i in range (0,len(onlyanswersets)):
		logFile.write("Doing the checking for check_answer"+str(i)+"\n")

		if incremental==2:
			# Feb 5 '19 - TRIAL
			if level<12:
				[abtext,level]=incrementalDebugOverGrid(i,temp,test,logFile,level)

			if i<len(onlyanswersets)-1:
				spamwriter.writerow(writer[index])
				index=index+1
				writer[index].append("")
				writer[index].append("")
				writer[index].append("next ans set")
			
			if abtext==False:
				copyfile("aux_reltypefacts_savedForLevel4Inc.lp","aux_reltypefacts.lp") 
			
		elif incremental==1:
			# Jan 27'19 : changed incremental case to only do incremental over debugging with args
			logFile.write("Running translatorMetaToNonGroundSpock.py " + test+"_input_meta\n")

			p= subprocess.Popen("python translatorMetaToNonGroundSpock.py {} ".format(test+"_input_meta"),shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
			output, err =p.communicate()
			p.wait()

			#creates _input_meta_debug
			outputFile2=test+"_input_meta_debug"
                    
			try:
				with open(outputFile2) as f:
					f.close()

			except IOError:
				print(outputFile2+ " does not exist. ")
				sys.exit()

			abtext=incrementalDebugOverTime(i,outputFile2,temp,test,mapping,logFile)

		if incremental==0 or abtext==False or level==12:

			logFile.write("Running translatorMetaToNonGroundSpock_withoutArg.py " + test+"_input_meta\n")

			p= subprocess.Popen("python translatorMetaToNonGroundSpock_withoutArg.py {} ".format(test+"_input_meta"),shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
			output, err =p.communicate()
			p.wait()
		
			#creates _input_meta_debug
			outputFile=test+"_input_meta_debug"

			try:
				with open(outputFile) as f:
					f.close()

			except IOError:
				print(outputFile+ " does not exist. ")
				sys.exit()
       
			
			mainlog+="debug without arguments\n"
			abtext=callClingoForDebugging(i,outputFile,temp,test,mapping,logFile)

                    	spamwriter.writerow(writer[index])
			index=index+1
			writer[index].append("")
			writer[index].append("")
			writer[index].append("")
			if abtext==[]:
				return 0
                    
			deactivatingrules=re.findall(r"ab_deactivated[A-Za-z]*\((\S*)\)",abtext)

			activatingpreds=re.findall(r"ab_activated\(([A-Za-z0-9\_]*)",abtext)
			if activatingpreds!=[]:
				activatingpreds=list(set(activatingpreds))
			print(deactivatingrules)
			print(activatingpreds) 	
                    

			#Jan 21'19 - when an incremental debugging is done, doing the debugging with a focus on some rules/preds sometimes returns unsat, 
			#           as they are not enough to find the reason for the spuriousness of only having time=1
			logFile.write("Running translatorMetaToNonGroundSpock.py " + test+"_input_meta "+",".join(deactivatingrules)+" "+",".join(activatingpreds)+"\n")
			p= subprocess.Popen("python translatorMetaToNonGroundSpock.py {} ".format(test+"_input_meta "+",".join(deactivatingrules)+" "+",".join(activatingpreds)+"\n"), shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
                    

                
			output, err =p.communicate()
			p.wait()
                    
                    
                    #creates _input_meta_debug
			outputFile2=test+"_input_meta_debug"
                    
			try:
				with open(outputFile2) as f:
					f.close()

			except IOError:
				print(outputFile2+ " does not exist. ")
				sys.exit()

			mainlog+="debug with arguments\n"
			abtext=callClingoForDebugging(i,outputFile2,temp,test,mapping,logFile)

                        
		if abtext==[]:
			return 0                        

		if refType==0:
			costnum=abtext.count("ab")
			if mincost==-1 or costnum<mincost:
				mincost=costnum
			cost.append(costnum)
                         
                            
			abtext=abtext.split(" ")
			abtext=[re.findall(r"(\d+)",a) for a in abtext if "refine" not in a]
			abtextnew=[a[1:] for a in abtext]
			abtextnewnew=[list(set(a)) for a in abtextnew]
			alloccurringabatoms=abtextnewnew
		else: 
			print("get ref atoms")
			print(abtext)
			abtext=abtext.split(" ")
			# Feb 5'19 - trying out refineCount thingy
			#abtext=[tuple(a[a.index("(")+1:a.index(")")].encode('utf-8').split(",")) for a in abtext if "refine(" in a]
			abtext=[tuple(a[a.index("(")+1:a.index(")")].encode('utf-8').split(",")) for a in abtext if "refineCountMain(" in a]
			if incremental==1 or incremental==2:
				abtexttemp=[a for a in abtext if a[3]!="1"]
				if abtexttemp!=[]:
					abtext=abtexttemp
			abtext.sort(key=lambda x: float(int(x[2])/int(x[3])), reverse=True)
			# Different ways of picking the occurring refine atoms
			abtext=[(a[0],a[1]) for a in abtext if float(int(a[2])/(int(a[3])*a[0].count("a")))==float(int(abtext[0][2])/(int(abtext[0][3])*abtext[0][0].count("a")))]
			#abtext=[(a[0],a[1]) for a in abtext if float(int(a[2])/int(a[3]))==float(int(abtext[0][2])/int(abtext[0][3]))]
			abtext.sort(key=lambda x: len(x[0])*len(x[1]))
			abtext=[(a[0],a[1]) for a in abtext if a[0].count("a")*a[1].count("b")==abtext[0][0].count("a")*abtext[0][1].count("b")]
			print(abtext)
			cost+=abtext
	print(cost)
	if refType==0:
		cost=[mincost]        
	return cost

def computeQuality(test,temp,mapping,answersets,logFile):
    unsatcounter=0
    allanssets=len(answersets)
    for ans in answersets:
        #creating the check file
        checkfile=open(test+ '_qualitycheck_answer', 'w')
        arr=ans.split(', ')
        for j in range(0, len(arr)):
            if arr[j].find("mapTo")==-1 and arr[j].find("_")!=0:
                checkfile.write("absexists("+ arr[j] + "). ")
        checkfile.close()
        clingo = subprocess.Popen("clingo {} ".format(test+' '+temp+'_checkrules'+' '+test+ '_qualitycheck_answer '+mapping+' reltype_computation/aux_nonbinaryrelations.lp aux_absregionfacts.lp'),
            shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
        clingoout, clingoerr = clingo.communicate()
        clingo.wait()
        del clingo
        clingoout = clingoout.decode('utf-8')
        if "UNSATISFIABLE" in clingoout:
            unsat=True
            unsatcounter=unsatcounter+1
    logFile.write("Has total of "+str(unsatcounter)+" spurious answer sets\n")        
    quality=float((allanssets-unsatcounter)/allanssets)
    return quality

def getCostOfMapping(test,mapping,pred,interestedatoms,interestedelts,refType,cellmapping,first):
	global mainlog
	global writer
	global index
	global level
	global checkedincs
	global incremental

	diversitycallscript="diverseAnsSets.py" 
    
	global alloccurringabatoms
	logFile=open('log_search.txt','w')

	if cellmapping==False:
		#call abs prog construction with pairs
		callscript="program_dom_abstraction_abstract_relations.py"
	else:
		#call abs prog construction with no pairs
		callscript="program_dom_abs_nonground_nopair_abs_rel_v4.py"
	if interestedelts!=[] and interestedatoms!=[]:		
		logFile.write("Running "+ callscript+' ' + test + ' ' + mapping + ' ' + pred + ' '+interestedatoms+' '+interestedelts+' '+first+ "\n")
		p= subprocess.Popen("python {} ".format(callscript+' '+test+ ' ' + mapping + ' ' + pred + ' '+interestedatoms+' '+interestedelts+' '+first),
				shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
		output, err =p.communicate()
		p.wait()
	elif interestedatoms!=[]:	
		logFile.write("Running python "+ callscript+' ' + test + ' ' + mapping + ' ' + pred + ' '+interestedatoms+' '+first+ "\n")
		p= subprocess.Popen("python {} ".format(callscript+' '+test+ ' ' + mapping + ' ' + pred + ' '+interestedatoms+' '+first),
				shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
		output, err =p.communicate()
		p.wait()		
	else:
		logFile.write("Running python "+ callscript+' ' + test + ' ' + mapping + ' ' + pred +' '+first+ "\n")
		p= subprocess.Popen("python {} ".format(callscript+' '+test+ ' ' + mapping + ' ' + pred+' '+first),
				shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
		output, err =p.communicate()
		p.wait()
	
	temp=test+"_input"


	if cellmapping==False:
		if os.path.isfile(temp)==True:
			temp1=test+"_input_abs_objname"
			temp2=test+"_input_absfacts"
		else:
			temp=test
			temp1=test+"_abs_objname"
			temp2=test+"_absfacts"
	else:
		if os.path.isfile(temp)==True:
			temp1=test+"_input_abs"
			temp2=test+"_input_absfacts"
		else:
			temp=test
			temp1=test+"_abs"
			temp2=test+"_absfacts"

	logFile.write("Outputs: "+ temp1 + ' '+ temp2 + "\n")
	logFile.write("\n")


        copyfile("aux_reltypefacts.lp","aux_reltypefacts_savedForLevel4Inc.lp")
	

	try:
		with open(temp1) as f:
			f.close()
	except IOError:
		print(temp1+ " does not exist. ")

	else:
		trycounter=0
		checkedincs=[]
		while True:
			logFile.write("Running "+diversitycallscript+" "+interestedatoms +" "+ temp1 + " "+ temp2 + " "+ mapping+ " aux_absregionfacts.lp aux_reltypefacts.lp 0\n")
			t = time.clock()
			p = subprocess.Popen(
				"python {} ".format(diversitycallscript+" "+interestedatoms +" "+ temp1 + " "+ temp2 + " "+mapping+" aux_absregionfacts.lp aux_reltypefacts.lp 0"),
				shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
			output, err =p.communicate()
			p.wait()
			del p
			logFile.write("Step2 is done." + "\n")
			logFile.write("\n")
		
			elapsed_time = time.clock() - t
			print(elapsed_time)
			mainlog+="getting abstract answer set\n"
			mainlog+="time for obtaining abstract answer sets: "+str(elapsed_time)+"\n"
			writer[index].append(str(elapsed_time))
			

			if output.find('displayed 0 answer sets') != -1:
				print(test+" is unsatisfiable!")
				print("testing the original program!")
				clingo = subprocess.Popen(
						"clingo {} ".format(test + ' reltype_computation/aux_nonbinaryrelations.lp'),
						 shell=True, stdout=subprocess.PIPE, stderr=sys.stderr)
				clingoout, clingoerr = clingo.communicate()
				clingo.wait()
				del clingo
				clingoout = clingoout.decode('utf-8')
				if clingoout.find('UNSATISFIABLE') == -1:
					print("PROGRAM IS ACTUALLY NOT UNSAT")
					logFile.write("PROGRAM IS ACTUALLY NOT UNSAT\n")
					sys.exit()
				return -1
		
			answersets=re.findall(r"INTERESTING  \[(.*)\]", output)
			logFile.write("Has total of "+str(len(answersets))+" diverse answer sets\n")
			logFile.write("Picking 5 random ones among all answer sets\n")
			if len(answersets)>5:
				randompickanswersets=random.sample(answersets, 5)
			else:
				randompickanswersets=answersets
	    	
			createCheckFile(randompickanswersets,logFile)
		
			cost=debugAnswerToGetCost(test,temp,mapping,randompickanswersets,logFile,refType,incremental)

			#if the random pick doesnt return any hints
			tryagain=False
			while cost==[]:
				alreadypicked=randompickanswersets
				print("the random pick didnt return any hints - trying again")
				logFile.write("the random pick didnt return any hints - trying again\n")
				answersets=[a for a in answersets if a not in alreadypicked]
				spamwriter.writerow(writer[index])
				index=index+1
				writer[index].append("")
				writer[index].append("")
				writer[index].append("tryagain")
				if len(answersets)>5:
					randompickanswersets=random.sample(answersets,5)
				elif len(answersets)==0:
					print("STOP - the found diverse ans sets dont return any hint")
					tryagain=True
					trycounter+=1
					if incremental==2:
						checkedincs.append(level)
					break
				else:
					randompickanswersets=answersets
				createCheckFile(randompickanswersets,logFile)
				cost=debugAnswerToGetCost(test,temp,mapping,randompickanswersets,logFile,refType,incremental)
				if cost!=[]:
					prevcost=cost
		
			if tryagain==True and trycounter<5:
				spamwriter.writerow(writer[index])
				index=index+1
				writer[index].append("")
				writer[index].append("")
				continue
			else:		
				if cost==0:
					logFile.write("Check the quality of the reached abstraction\n")
					print("Check the quality of the reached abstraction")
					quality=computeQuality(test,temp,mapping,answersets,logFile)
					print("quality of abstraction is %.2f" % (quality))
					logFile.write("quality of abstraction is %.2f" % (quality)+"\n")
					sys.exit()

				#Jan 28'19 : if only one diverse ans set exists, below returns all found regions as cost so all of them get refined 
				#             - but if many diverse ans sets return same costs, only one region is picked - not sure if this difference ok or bad - changed it now
				if refType==1:
					if trycounter==5:
						# FIXME leaving the loop after 5 counts doesn't work TODO
						if prevcost==[]:
							print "no other cost to pick"
							sys.exit()
						else:
							pickedcost=random.sample(prevcost, 1)
					else:
						if len(answersets)>1:
							pickedcost=getMostOccurringHint(cost)
						else:
							pickedcost=random.sample(cost, 1)
							prevcost=[p for p in cost if p!=pickedcost]
				else:
					pickedcost=cost
				writer[index].append(pickedcost)
				return pickedcost
    
#Jan 24'19 - picks the most occurring region and returns that one   
#Feb 4'19  - well, if there are more than one most occurring atom, then picks randomly
def getMostOccurringHint(arr):    
    mostcommonarr=Counter(arr).most_common()
    sortAccToOcc=[t[0] for t in mostcommonarr if t[1]==mostcommonarr[0][1]]
    # Feb 9'19 - picking among the smallest in size
    sortAccToOcc.sort(key=lambda x: x[0].count("a")*x[1].count("b"))
    pickfromsmallest=[t for t in sortAccToOcc if t[0].count("a")*t[1].count("b")==sortAccToOcc[0][0].count("a")*sortAccToOcc[0][1].count("b")]
    return random.sample(pickfromsmallest,1)
     

def makeMappingToRegion(region):
	#assuming [0] has format a0a1a2a3... [1] has format b0b1b2b3...
	orgeltsa=region[0].split("a")[1:]
	orgeltsb=region[1].split("b")[1:]
	mapto=[]
	for a in orgeltsa:
		for b in orgeltsb:
			mapto.append((a,b,region[0],region[1]))
	return mapto

def refineRegionToOrg(region):
    refmap=[]
    refregs=[]
    for x in region[0].split("a")[1:]:
        for y in region[1].split("b")[1:]:
            refmap.append(makeMappingToRegion(("a"+x,"b"+y)))
            refregs.append(("a"+x,"b"+y))
    return [refregs,refmap]

def refineRegion(region):
	if region[0].count("a")>1:
		if region[0].count("a")%2==0:
			regionxref=[region[0][:int(len(region[0])/2)],region[0][int(len(region[0])/2):]]
		else:
			if region[0].count("a")==3:
				regionxref=[region[0][:int(len(region[0])/3)],region[0][int(len(region[0])/3):int(len(region[0])*2/3)],region[0][int(len(region[0])*2/3):]]    
			else:
				regionxref=[region[0][:int(len(region[0])/2)-1],region[0][int(len(region[0])/2)-1:]]            
	else:
		regionxref=[region[0]]
	if region[1].count("b")>1:
		if region[1].count("b")%2==0:
			regionyref=[region[1][:int(len(region[1])/2)],region[1][int(len(region[1])/2):]]
		else:
			if region[1].count("b")==3:
				regionyref=[region[1][:int(len(region[1])/3)],region[1][int(len(region[1])/3):int(len(region[1])*2/3)],region[1][int(len(region[1])*2/3):]]    
			else:
				regionyref=[region[1][:int(len(region[1])/2)-1],region[1][int(len(region[1])/2)-1:]]
	else:
		regionyref=[region[1]]
	refmap=[]
	refregs=[]
	for x in regionxref:
		for y in regionyref:
			refmap.append(makeMappingToRegion((x,y)))
			refregs.append((x,y))
	return [refregs,refmap]

def isCluster(reg):
    if reg[0].count("a")>1:
        return True
    elif reg[1].count("b")>1:
        return True
    else:
        return False

def getPossibleRefinements(absdoms,step):
	print(absdoms)
	if step==0:
		return absdoms
	#Jan 8'19 - only consider combinations of refinements of the actual clusters in the abs domain
	realclusters=[k for k in absdoms if isCluster(k)==True]
	listing=[]
	#maxrefregionnum=len(realclusters)
	maxrefregionnum=1
	for i in range(0,maxrefregionnum+1):
		listing=listing+[list(x) for x in itertools.combinations(realclusters, i)]
	allrefs=[]
	#Jan 8'19 - started the loop from the 1st elt instead of 0 so that the refinement with no regions refined is not considered
	for l in range(1,len(listing)):
		remabsdoms=[i for i in absdoms if i not in listing[l]]
		refregs=[]
		rregtemp=[]
		for reg in listing[l]:
			refregs.append(refineRegion(reg)[0])
		for rr in refregs:
			rregtemp+=[r for r in rr]
		allrefs.append([rregtemp+remabsdoms])
	return allrefs		
	
			
def refineGivenRegions(absdoms,regions):
    newmapping=[]
    for a in absdoms:
        if a in regions:
            newmapping+=refineRegion(a)[0]
        else:
            newmapping.append(a)
    return newmapping

def createIncMappingFile(absdom,inclevel,filename,pred):
	maptext=""
	for a in inclevel:
		for b in absdom:
			if a[0] in b[0] and a[1] in b[1]:
				maptext=maptext+"mapTo("+pred.replace(",","_")+","+a[0]+","+a[1]+","+b[0]+","+b[1]+").\n"
	fout=open(filename,"w")
	fout.write(maptext)
	fout.close()

def createMappingFile(absdom,filename,pred,cellmapping,inc):
	arr=[]
	domtext=""
	for a in absdom:
		arr.append(makeMappingToRegion(a))
	text=""
	maptext=""
	for a in range(0, len(arr)):
		for b in range(0, len(arr[a])):
			if cellmapping==False:
				text=text+"dom("+pred.replace(",","_")+","+arr[a][b][0]+","+arr[a][b][1]+").\n"
				maptext=maptext+"mapTo("+pred.replace(",","_")+","+arr[a][b][0]+","+arr[a][b][1]+","+arr[a][b][2]+","+arr[a][b][3]+").\n"
			else:
				text=text+"dom("+pred.replace(",","_")+",("+arr[a][b][0]+","+arr[a][b][1]+")).\n"
				maptext=maptext+"mapTo("+pred.replace(",","_")+",("+arr[a][b][0]+","+arr[a][b][1]+"),("+arr[a][b][2]+","+arr[a][b][3]+")).\n"
	if cellmapping==False:
		additionaltext="\ncell(X,Y) :- mapTo(row_column,_,_,X,Y).\n"  
	else:
		additionaltext=""
	if inc==True:
		maptext=maptext.replace("mapTo","mapOrgToInc")   
		additionaltext=additionaltext.replace("mapTo","mapOrgToInc")   
	if filename=="":
		return text+maptext+domtext+additionaltext
	else:
		fout=open(filename,"w")
		fout.write(text+maptext+domtext+additionaltext)
		fout.close()

def processText(mappingtext):
	mappingtext=re.sub(r'(%.*\n)', r'',mappingtext)
	cellmappiing=re.findall(r"mapTo\(.*,\ *\((\S+),\ *(\S+)\),\ *\((\S+),\ *(\S+)\)\).",mappingtext)
	if cellmappiing==[]:
		mappiing=re.findall(r"mapTo\(.*,\ *(\S+),\ *(\S+),\ *(\S+),\ *(\S+)\).",mappingtext)
		cellmapping=False
	else:
		cellmapping=True
		mappiing=cellmappiing
	absdom=list(set([(m[2],m[3]) for m in mappiing]))
	absclusters=[[] for i in range(len(absdom))]
	for i in range(len(absdom)):
		for m in mappiing:
			if (m[2],m[3])==absdom[i]:
				absclusters[i].append((m[0],m[1]))
  
	return [absdom,absclusters,cellmapping]

def listOfListToText(m):
	text="%["
	for k1 in m:
		text=text+"["
		for k2 in k1:
			text=text+str(k2)+","
		#print text
		text=text[:len(text)-1]+"],"
	text=text[:len(text)-1]+"]\n"	
	return text

run=0
maxrun=1
incremental=2
#incremental types:
# 0: usual checking, first checks with no arguments then with arguments
# 1: incremental over "time"
# 2: incremental concretization of the grid-cell

test=sys.argv[1]

print test[:test.rfind("/")+1]+"logs/logfile_runs_"+test[test.rfind("/")+1:test.find(".lp")]+".csv"
csvfile= open(test[:test.rfind("/")+1]+"logs/logfile_runs_"+test[test.rfind("/")+1:test.find(".lp")]+".csv", 'w')
spamwriter=csv.writer(csvfile, delimiter=' ', quoting=csv.QUOTE_MINIMAL)
writer=[[]*7 for x in xrange(1000)]
writer[0].append("Name")
writer[0].append("Run")
writer[0].append("Abs Answer Computation Time")
writer[0].append("Check Time")
writer[0].append("Refined Region")
writer[0].append("Total Refinement Step")
writer[0].append("Result Mapping")
spamwriter.writerow(writer[0])

	
index=1
while run<maxrun:
	
	#Fec 10'19 keeping the list of checked incremental levels - it is needed when a loop occurs due to not finding hints
	checkedincs=[]
	level=0
	writer[index].append(test[test.rfind("/")+1:])

	mapping=sys.argv[2]
	pred= sys.argv[3]
	size= int(sys.argv[4])
	refinetype= int(sys.argv[5])
	
	realfilename=re.findall("([^/]+.lp)",test)[0]
	interestedatoms=[]
	if len(sys.argv) ==7:
		interestedatoms=sys.argv[6]

	interestedelts=[]
	if len(sys.argv) ==8:
		interestedelts=sys.argv[7]

	for filename in glob.glob(test+"_*"):
	    os.remove(filename) 

	#TODO read mapping from a file with mapTo, convert it to array of arrays
	if os.path.isfile(mapping):
		fin=open(mapping,"r")
		mappingtext=fin.read()
		fin.close()
		[absdom,absclusters,cellmapping]=processText(mappingtext)
	else:
		print "mapping is not a file"
		sys.exit()

	print(absdom)
	print(absclusters)

	mainlog=""

	print("creating mapping file")
	filename="generated_mappings/mapping_init.lp"
	createMappingFile(absdom,filename,pred,cellmapping,False)
	alloccurringabatoms=[]
	print("getting cost of init mapping")
	first=""
	cost=getCostOfMapping(test,filename,pred,interestedatoms,interestedelts,refinetype,cellmapping,first)

	spamwriter.writerow(writer[index])
	index=index+1
	writer[index].append("")
	writer[index].append("")

	if cellmapping==False:
	    first="--firsttime=False"

	print(cost)

	mapping=absdom

	if cost==-1:
		print("prog is unsat!")
		fout=open(test[:test.rfind("/")+1]+"logs/result_run"+str(run+1)+"_"+test[test.rfind("/")+1:],"w")
		fout.write(createMappingFile(mapping,"",pred,cellmapping,False))
		fout.close()
		sys.exit()


	refinementstep=0
	if refinetype==1:
		while True:
			refinementstep+=1
			mapping=refineGivenRegions(mapping,cost)
			print("refined mapping to")
			print(mapping)
			absdom=mapping
		
			filename="generated_mappings/mapping_refine_1.lp"
			createMappingFile(mapping,filename,pred,cellmapping,False)
		
			cost=getCostOfMapping(test,filename,pred,interestedatoms,interestedelts,refinetype,cellmapping,first)
		
			#Jan 21'19 assuming something will make it stop and wont loop forever..
			print(cost)
			if cost==-1:
				print("prog is unsat!")
				mainlog+="total refinement steps: "+str(refinementstep)+"\n"
				mainlog+="resulting abstraction:"
				mainlog+=" ".join(["("+a[0]+","+a[1]+")" for a in absdom])
				fout=open(test[:test.rfind("/")+1]+"logs/log_run"+str(run+1)+"_"+test[test.rfind("/")+1:],"w")
				print test[:test.rfind("/")+1]+"logs/log_run"+str(run+1)+"_"+test[test.rfind("/")+1:]
				fout.write(mainlog)
				fout.close()
				writer[index].append("")
				writer[index].append("")
				writer[index].append(str(refinementstep))
				writer[index].append(" ".join(["("+a[0]+","+a[1]+")" for a in absdom]))
				spamwriter.writerow(writer[index])
				index=index+1
				fout=open(test[:test.rfind("/")+1]+"logs/result_run"+str(run+1)+"_"+test[test.rfind("/")+1:],"w")
				fout.write(createMappingFile(mapping,"",pred,cellmapping,False))
				fout.close()
				break

			spamwriter.writerow(writer[index])
			index=index+1
			writer[index].append("")
			writer[index].append("")
	else:
		if cost==0 or cost==-1:
			fout=open(test+"_result","w")
			fout.write(listOfListToText(mapping)+createMappingFile(mapping,"",pred,cellmapping,False))
			fout.close()
			sys.exit()
		while True:
			print("computing all refinements")
			allrefinements=getPossibleRefinements(mapping,1)
			print("there are total of "+str(len(allrefinements))+" refinements")
			refinecosts=[[] for i in range(len(allrefinements))]
			for j in range(0,len(allrefinements)):
				print("computing cost of "+str(j)   )   
				filename="generated_mappings/mapping_refine_1.lp"
				createMappingFile(allrefinements[j][0],filename,pred,cellmapping,False)
				alloccurringabatoms=[]
				cost=getCostOfMapping(test,filename,pred,interestedatoms,interestedelts,refinetype,cellmapping,first)
				#print alloccurringabatoms
				print(cost)
				refinecosts[j].append(cost)
				if cost==0 or cost==-1:
					fout=open(test+"_result","w")
					fout.write(listOfListToText(allrefinements[j][0])+createMappingFile(allrefinements[j][0],"",pred,cellmapping,False))
					fout.close()
				#print allprintedtests[i]
					sys.exit()
			
			
			#print allrefinements
			print(refinecosts)
			mini=[]
			for i in range(0,len(refinecosts)):
				for j in range(0,len(refinecosts[i])):
					if mini==[]:
						mini=[refinecosts[i][j], (i,j)]
					else:
						if mini[0]>refinecosts[i][j]:
							mini=[refinecosts[i][j], (i,j)]
						elif mini[0]==refinecosts[i][j]:
							mini.append((i,j))

			print(mini)
			if mini==[]:
				print("no further refinement will be done")
				break		
			randompick=randint(1, len(mini)-1)
			print("picked for refinement in random "+str(randompick))
			mapping=allrefinements[mini[randompick][0]][mini[randompick][1]]
			print(mapping)
		
		run+=1
   
   


	


