#Feb 14'19 
#Author : Zeynep G. Saribatur

import re
import pexpect
import time
import sys
import csv
import string
import os
import itertools
from shutil import copyfile

class meta:
	def __init__(self,textOrg,sp,dap,absinfo):
		self.rules=re.findall(r"rule\((\S+)\).",textOrg)
		self.head=re.findall(r"head\((\S+),\ *(\S+)\).",textOrg)
		self.negbody=re.findall(r"negbody\((\S+),\ *(\S+)\).",textOrg)
		self.posbody=re.findall(r"posbody\((\S+),\ *(\S+)\).",textOrg)
		self.pred=re.findall(r"pred\((\S+),\ *(\S+)\).",textOrg)
		self.struct=re.findall(r"struct\((\S+),\ *(\d+),\ *(\S+),\ *(\S+)\).",textOrg)
		self.arity=re.findall(r"arity\((\S+),\ *(\d+)\).",textOrg)
		self.var=re.findall(r"var\((\S+),\ *(\S+)\).",textOrg)
		self.atoms=[]
		self.predList=[]
		self.ruleRel=[]
		self.sharesRelPlus=[]
		self.sharesRelMinus=[]
		self.sharesHeadRel=[]
		self.predRelVar=[]
		self.predRelVarNonBin=[]
		self.knownBuiltinBinaryRels=["equ","neq","less","geq","greater","leq"]
		self.knownBuiltinNonBinaryRels=["plus","plus1","minus","neqEqu","equEqu4","equEqu3","neqNeq","leqLess","lessLess","leqEqu","lessEqu","leqLeq3","lessLeq3","lessLeq3X","lessLeq3Y","leqLess3","leqLess3X","leqLess3Y","equNeq4"]
		self.specialPreds=self.knownBuiltinBinaryRels+self.knownBuiltinNonBinaryRels+sp
		self.facts=[]
		self.factPreds=[]
		self.absAtoms=[]
		self.cyclicDep=[]
		self.atomPredList=[]
		self.atomList=[]
		self.domAbsPred=dap
		self.domAbsUsedVars=[]
		self.varpairs=[]
		self.mapping=absinfo[0]
		self.abstractedAtoms=[]
		self.inputPredsRelatedWithAbs=[]


	def initializeAtoms(self):
		self.getFacts()
		atomlist=[]
		for pr in self.pred:
			factusedwithtwodoms=False
			if "neg_" in pr[1]:
				prtemp=pr[1].replace("neg_","-")
			elif "MINUS" in pr[1]:
				prtemp=pr[1].replace('MINUS','-')
			else:
				prtemp=pr[1]
			if pr[0] in self.factPreds:
				fact=True
				exists=True
				textAbsAtom=prtemp+"("
			else:
				fact=False
				if pr[1] not in self.knownBuiltinBinaryRels and pr[1] not in self.knownBuiltinNonBinaryRels:
					exists=False
					for k in atomlist:
						if k==prtemp and self.checkIfPredHasNonDomAbsArg(pr[0])==False:# or pr[1] in self.inputPredsRelatedWithAbs:
							exists=True
							break
					if exists==False:
						atomlist.append(prtemp)
						textCheckAtom=prtemp+"("
				else:
					exists=True
			if pr[1] in self.knownBuiltinBinaryRels:
				var1=""
				var2=""
			elif pr[1] in self.knownBuiltinNonBinaryRels:
				var1=""
				var2=""
				var3=""
				var4=""
			else:
				textAtom=prtemp+"("
			argtemp=m.getArgs(pr[0])
			noneedtoadd=False
			if argtemp!=[]:
				index=1
				argHasNotVar=False
				if len(argtemp)==1 and pr[1] in self.domAbsPred:
					self.domAbsUsedVars.append([pr[0],pr[1],argtemp[0].replace("v","")])
				for ii in range(0,len(argtemp)):
					arg=argtemp[ii]			
					if re.search('v[A-Z]', arg)!=None:
						arg=arg.replace("v","")
					if re.search('v_', arg)!=None:
						arg=arg.replace("v","")
					#FIXME this is to deal with replaced time variables - make it better 
					if arg=="TPLUS1":
						arg="T+1"
					elif arg=="TMINUS1":
						arg="T-1"
					elif "MINUS" in arg:
						arg=arg.replace('MINUS','-')
					if  pr[1] in self.knownBuiltinBinaryRels:
						if var1=="":
							var1=arg
						else:
							var2=arg
							if pr[1]=="equ":
								if not self.checkIfPredHasDomAbsArg(pr[0]):
									textAtom=var1+"="+var2
								else:
									textAtom="equ("+var1+","+var2+")"
							elif pr[1]=="neq":
								if not self.checkIfPredHasDomAbsArg(pr[0]):
									textAtom=var1+"!="+var2
								else:
									textAtom="neq("+var1+","+var2+")"
							elif pr[1]=="less":
								if not self.checkIfPredHasDomAbsArg(pr[0]):
									textAtom=var1+"<"+var2
								else:
									textAtom="less("+var1+","+var2+")"
							elif pr[1]=="greater":
								if not self.checkIfPredHasDomAbsArg(pr[0]):
									textAtom=var1+">"+var2
								else:
									textAtom="greater("+var1+","+var2+")"
							elif pr[1]=="geq":
								if not self.checkIfPredHasDomAbsArg(pr[0]):
									textAtom=var1+">="+var2
								else:
									textAtom="geq("+var1+","+var2+")"
							elif pr[1]=="leq":
								if not self.checkIfPredHasDomAbsArg(pr[0]):
									textAtom=var1+"<="+var2
								else:
									textAtom="leq("+var1+","+var2+")"
							self.predRelVar.append([pr[0], pr[1], var1, var2])
					elif pr[1] in self.knownBuiltinNonBinaryRels:
						if var1=="":
							var1=arg
						elif var2=="":
							var2=arg
						elif var3=="":
							var3=arg
							if len(argtemp)==3:
								textAtom=pr[1]+"("+var1+","+var2+","+var3+")"
								self.predRelVarNonBin.append([pr[0], pr[1], var1, var2, var3])
						else:
							var4=arg
							textAtom=pr[1]+"("+var1+","+var2+","+var3+","+var4+")"
							self.predRelVarNonBin.append([pr[0], pr[1], var1, var2, var3, var4])
					else:
						textAtom=textAtom+arg+","
						if fact==True:
							#it's a fact but does it have abstracted arguments?
							#a function to check if fact has relation to domabs
							ans=self.checkFactHasAbs(pr[1],ii)
							if True in ans:
								if len(ans[1])==1:
									textAbsAtom=textAbsAtom+"X"+ans[1][0].upper()+str(index)+","
								# Feb 7'19 - can also be a second dom abs name used with fact..
								else:
									if index==1:
										textAbsAtom=[textAbsAtom+"X"+ans[1][0].upper()+str(index)+",",textAbsAtom+"X"+ans[1][1].upper()+str(index)+","]
									else:	
										textAbsAtom=[textAbsAtom[0]+"X"+ans[1][0].upper()+str(index)+",",textAbsAtom[1]+"X"+ans[1][1].upper()+str(index)+","]
									factusedwithtwodoms=True
							else:
								textAbsAtom=textAbsAtom+arg+","
						if exists==False:
							rulename=re.findall(r"(r\d+)[bh]",pr[0])[0]
							ans=self.checkArgExistInAbsPred(rulename,arg)
							if False in ans:
								#print arg + " do not exist in abs pred "+rulename
								textCheckAtom=textCheckAtom+arg+","
								if re.search(r"[A-Z]",arg[0])==None:
									argHasNotVar=True
							else:
								textCheckAtom=textCheckAtom+"X"+ans[1].upper()+str(index)+","
								
					index=index+1				
				if pr[1] not in self.knownBuiltinBinaryRels and pr[1] not in self.knownBuiltinNonBinaryRels:
					textAtom=textAtom[:len(textAtom)-1]+")"	
					if fact==True:
						if factusedwithtwodoms==True:
							textAbsAtom=[textAbsAtom[0][:len(textAbsAtom[0])-1]+")",textAbsAtom[1][:len(textAbsAtom[1])-1]+")"]
						else:
							textAbsAtom=textAbsAtom[:len(textAbsAtom)-1]+")"
					if exists==False:
						textCheckAtom=textCheckAtom[:len(textCheckAtom)-1]+")"
						if argHasNotVar==False and prtemp in atomlist:
							if self.checkIfAlreadyExistsWithVars(len(argtemp),self.atomList,prtemp)==True:
								noneedtoadd=True
			else:
				textAtom=textAtom[:len(textAtom)-1]
				if fact==True:
					textAbsAtom=textAbsAtom[:len(textAbsAtom)-1]	
				if exists==False:
					textCheckAtom=textCheckAtom[:len(textCheckAtom)-1]	
			self.atoms.append([pr[0],textAtom])
			if "(" in textAtom and "," in textAtom and [z for z in self.knownBuiltinBinaryRels if z in textAtom]==[]:				
				self.varpairs.append([pr[0],textAtom[textAtom.index("(")+1:textAtom.index(")")]])
			if fact==True:
				if factusedwithtwodoms==True:
					self.absAtoms.append([pr[0],textAbsAtom[0]])
					self.absAtoms.append([pr[0],textAbsAtom[1]])
				else:
					self.absAtoms.append([pr[0],textAbsAtom])
			if exists==False:
				if noneedtoadd==False:
					self.atomList.append([pr[0],textCheckAtom])
				else:
					atomlist=atomlist[:len(atomlist)-1]
		self.atomList=[a[1] for a in self.atomList]
		for ar in self.arity:
			self.predList.append(ar[0])
		self.obtainRel()

	def printout(self):
		print("------------")
		#print self.rules
		#print self.head
		#print self.negbody
		#print self.posbody
		#print self.pred
		#print self.struct
		#print self.arity
		#print self.var
		#print self.facts
		#print self.factPreds
		print self.absAtoms
		print("initialized")
		#print(self.atoms)
		#print(self.varpairs)
		#print self.predList
		#print self.predRelVar
		#print self.predRelVarNonBin
		#print "rel rule"
		#print self.ruleRel
		#print "S^+ rel rule"
		#print self.sharesRelPlus
		#print "S^- rel rule"
		#print self.sharesRelMinus
	
	def getPred(self,p): 
		return [a[1] for a in self.pred if a[0]==p][0]
	def getHead(self,r):
		h=[a[1] for a in self.head if a[0]==r]
		if h==[]:
			h=[[]]
		return h 
	def getPosbody(self,r):
		return [a[1] for a in self.posbody if a[0]==r] 
	def getNegbody(self,r):
		return [a[1] for a in self.negbody if a[0]==r] 
	def getArity(self,p):
		return int([a[1] for a in self.arity if a[0]==p][0])
	def getArgs(self,p):
		return [a[3] for a in self.struct if a[0]==p] 
	def getType(self,p):
		return [a[2] for a in self.struct if a[0]==p][0] 
	def getPredSym(self,p):
		return [a[0] for a in self.pred if a[1]==p]
	
	
	def getAtom(self,r):
		return [a[1] for a in self.atoms if a[0]==r]

	def getSplus(self,r,rel):
		return [a[1] for a in self.sharesRelPlus if a[0]==r and a[2]==rel]
	def getSminus(self,r,rel):
		return [a[1] for a in self.sharesRelMinus if a[0]==r and a[2]==rel]
    
	def getSplusAll(self,r,relall):
		gather=[]
		for rel in relall:
			gather+=[a[1] for a in self.sharesRelPlus if a[0]==r and a[2]==rel]
		return gather
	def getSminusAll(self,r,relall):
		gather=[]
		for rel in relall:
			gather+=[a[1] for a in self.sharesRelMinus if a[0]==r and a[2]==rel]
		return gather
    
	def getRelShareHead(self,r):
		return [[a[1],a[2]] for a in self.sharesHeadRel if a[0]==r]
	def getRelShareHeadIndex(self,r,rel):
		return [a[3] for a in self.sharesHeadRel if a[0]==r and a[2]==rel]


	def checkIfAlreadyExistsWithVars(self,n,arr,pred):
		searchtext="\A"+pred+"\([A-Z][A-Za-z]*\d*"
		for i in range(1,n):		
			searchtext=searchtext+",\ *[A-Z][A-Za-z]*\d*"
		for a in arr:
			if re.search(searchtext,a[1])!=None:
				return True
		return False

	def obtainRel(self):
		for a in self.rules:
			foundrel=False
			reltempall=[]
			for b in self.pred:
				if a+"b" in b[0] and (b[1] in self.knownBuiltinBinaryRels or b[1] in self.knownBuiltinNonBinaryRels):
					self.ruleRel.append([a,b[0],b[1]])
					foundrel=True
					reltempall.append(b[0])
			if not foundrel:
				self.ruleRel.append([a,"none","none"])
			else:
				for b in self.getPosbody(a):
					for reltemp in reltempall:
						if b!=reltemp and self.getPred(b) not in self.specialPreds:
							ret=self.checkVarShare(b,reltemp)
							if ret!=[]:
								for c in ret:
									self.sharesRelPlus.append([a,b,reltemp])
				for b in self.getNegbody(a):
					for reltemp in reltempall:
						if b!=reltemp and self.getPred(b) not in self.specialPreds:
							ret=self.checkVarShare(b,reltemp)
							if ret!=[]:
								for c in ret:
 									self.sharesRelMinus.append([a,b,reltemp])
				b=self.getHead(a)[0]
				if b==[]:
					self.sharesHeadRel.append([a,"none","none"])
				else:
					for reltemp in reltempall:
						ret=self.checkVarShare(b,reltemp)
						if ret!=[]:
							for c in ret:
								index=self.getVarIndexInRel(c,reltemp)[0]
								self.sharesHeadRel.append([a,b,reltemp,index])
	def getFacts(self):
		for a in self.rules:
			if self.getPosbody(a)==[] and self.getNegbody(a)==[]:
				self.facts.append(a)
				#FIXME for now assuming head has one atom!
				self.factPreds.append(self.getHead(a)[0])
	

	def checkVarShare(self,a,b):
		aVarList=[k[3] for k in self.struct if k[0]==a and k[2]=="var"]
		bVarList=[k[3] for k in self.struct if k[0]==b and k[2]=="var"]
		return list(set(aVarList) & set(bVarList))

	def getVarIndexInRel(self,var,a):
		return [k[1] for k in self.struct if k[0]==a and k[3]==var]

	def headSharesVarWithS(self,head,array):
		if head==[] or head==['none']:
			return False
		for a in array:
			ret=self.checkVarShare(head[0],a)
			if ret!=[]:
				if True in self.checkArgExistInAbsPred(head[0][0]+head[0][1],ret[0]):
			#		print "indeed is related with abs pred"
					return True
			#	print "not related with abs pred"
		return False

		
	def checkArgExistInAbsPred(self,r,arg):
		posbody=self.getPosbody(r)
		for p in posbody:
			ppred=self.getPred(p)	
			if ppred in self.domAbsPred:
				arglist=[k[3] for k in self.struct if k[0]==p]
				if arg in arglist:
					return [True,ppred]
				if "v"+arg in arglist:
					return [True,ppred]
		return [False]
	
	def checkFactHasAbs(self,p,index):
		#print "checking "+p+" for argument "+str(index)
		rulename=""
		collectrulenames=[]
		relatedabspreds=[]
		for k in self.pred:
			if k[1]==p and "b" in k[0]:
				collectrulenames.append([k[0],re.findall(r"(r\d+)[bh]",k[0])[0]])
		if collectrulenames==[]:
			#print "no rule uses this fact!"
			return [False]
		else:
			for c in collectrulenames:
				#print "rule "+rulename+" contains this pred"
				arg=self.getArgs(c[0])[index]
				ans=self.checkArgExistInAbsPred(c[1],arg)
				if True in ans:
				#	print "fact indeed has abs arg"
					if ans[1] not in relatedabspreds:
						relatedabspreds.append(ans[1])
			#print "fact does NOT have abs arg"
			if relatedabspreds==[]:
				return [False]
			else:
				return [True,relatedabspreds]
				

	def getDomAbsPredsInRule(self,r):
		return [p for p in self.getPosbody(r) if self.getPred(p) in self.domAbsPred]

	def checkIfPredHasNonDomAbsArg(self,checkp):
		rulename=re.findall(r"(r\d+)[bh]",checkp)[0]
		domabspredlist=self.getDomAbsPredsInRule(rulename)
		domabsargs=[k[3] for k in self.struct if k[0] in domabspredlist]
		mypredargs=[k[3] for k in self.struct if k[0]==checkp]
		for i in mypredargs:
			if i not in domabsargs:
				return True
		return False

	def checkIfPredHasDomAbsArg(self,checkp):
		rulename=re.findall(r"(r\d+)[bh]",checkp)[0]
		domabspredlist=self.getDomAbsPredsInRule(rulename)
		domabsargs=[k[3] for k in self.struct if k[0] in domabspredlist]
		mypredargs=[k[3] for k in self.struct if k[0]==checkp]
		for i in mypredargs:
			if i in domabsargs:
				return True
		return False

	def checkIfRelatedWithAbsPred(self,r,checkp):
		global domAbsPreds
		posbody=self.getPosbody(r)
		collectvar=[]
		collectindex=[]
		for p in posbody:
			ppred=self.getPred(p)	
			if ppred in domAbsPreds:
				ret=self.checkVarShare(checkp,p)
				if ret!=[]:
					collectvar.append(ret[0])
					collectindex.append(domAbsPreds.index(ppred))
					#print p +" "+ checkp+" shares "+",".join(ret)
					#here is assuming that the rel is related with only one abs pred, so there is no X<Y , row(X), col(Y).
					#thus, just returning one index of which pred the rel is related with is enough 
		if collectvar!=[]:
			return ["True",collectvar,collectindex]
		else:
			return ["False"]

	def checkWhichVarPairExistsInRule(self,r,var):
		pairedwith=[]
		for i in self.varpairs:
			if r+"h" in i[0] or r+"b" in i[0]:
				what=re.findall("(\S+), *"+var+"(?![0-9])",i[1])
				if what!=[]:
					what=what[0]
					if "," in what:
						what=what[what.rfind(",")+1:]
					res=self.checkIfRelatedWithAbsPred(r,i[0])
					# Jan 31'19 - since this function is called only when there is a second relation in the rule
					#              then we need to find the pair relation among the vars
					#              ASSUMING that the second rel is with the second domabspred, we need find a pair with first domabspred
					if res[2][res[1].index("v"+what)]==0:
						pairedwith.append(what)
		pairedwith=list(set(pairedwith))
		return pairedwith
    
	def fillRemainingVarsWithPairs(self,r,arr):
		varsInRule=[z for z in self.domAbsUsedVars if r+"b" in z[0]]
		needpairsforindex=[]
		for v in varsInRule:
			if v[2] in arr and v[1]==self.domAbsPred[0]:
				k=arr.index(v[2])
				if len(arr)>k+1:
					if [z for z in varsInRule if z[2]==arr[k+1]][0][1]!=self.domAbsPred[1]:
						#has no pair, need to find its pair
						needpairsforindex.append(k)
				else:
					#has no pair, need to find its pair
					needpairsforindex.append(k)
		for v in varsInRule:
			if v[1]==self.domAbsPred[1]:
				pairedwith=self.checkWhichVarPairExistsInRule(r,v[2])
				for p in pairedwith:
					if p in arr and arr.index(p) in needpairsforindex:
						arr.insert(arr.index(p)+1,v[2])
		return arr
                        
            
        
	def getVarPairFromDomAbsPredOrder(self,r,var):
		varsInRule=[z for z in self.domAbsUsedVars if r+"b" in z[0]]
		atom=[z for z in varsInRule if z[2]==var][0]
		if atom[1]==self.domAbsPred[0]:
			getNextAtom=varsInRule[varsInRule.index(atom)+1]
			if getNextAtom[1]==self.domAbsPred[1]:
				return getNextAtom[2]
			else:
				print("---SOMETHING'S WRONG-1--")
		elif atom[1]==self.domAbsPred[1]:
			getPrevAtom=varsInRule[varsInRule.index(atom)-1]
			if getPrevAtom[1]==self.domAbsPred[0]:
				return getPrevAtom[2]
			else:
				print("---SOMETHING'S WRONG-2--")
		else:
			print("---SOMETHING'S WRONG-3--")

	def ifHasConstantMakeAbstract(self,p,patom):
		const=[k[3] for k in self.struct if k[0]==p and k[2]=="const"]
		#print const
		if const!=[]:
			for m in self.mapping:
				if m[0]==const[0]:
					#TODO need an another additional check on whether the constant is indeed from the abs domain!
					patomtemp=re.sub(r'([\,\(\=\<])'+const[0],r'\1'+m[1],patom)		
					if [patom,patomtemp] not in self.abstractedAtoms:
						self.abstractedAtoms.append([patom,patomtemp])
					return patomtemp
		return patom

	def checkIfInertia(self,r):
		head=self.getHead(r)[0]
		if head!=[]:
			headpred=self.getPred(head)
			negbody=self.getNegbody(r)
			if len(negbody)==1:
				negpred=self.getPred(negbody[0])
				if negpred=="neg"+headpred:
					#TODO need to further check whether they share the same arguments!!
					return True
		return False
						


	def hasConstant(self,p):
		const=[k[3] for k in self.struct if k[0]==p and k[2]=="const"]
		if const!=[]:
			return True
		return False
	
	def processFactsToAbstractFacts(self):
		absfactstext=""
		for a in self.absAtoms:
			# Jan 16 '19 changed using a[1] to using atemp in which "MINUS" is changed to "-"
			atemp=re.sub(r'([^T])MINUS',r'\1-',a[1])
			if "_"+atemp not in absfactstext:
				indeces=re.findall(r"X(([A-Z]*)\d+)",atemp)
				k=[]
				if indeces!=[]:
					abshead=atemp.replace("X","A")
					text=abshead+":-"+"_"+atemp+","
					skipnext=False
					for ii in range(0,len(indeces)):
						if skipnext==True:
							skipnext=False
							continue
						i=indeces[ii]
						if i[1].lower() in domAbsPreds and len(indeces)>ii+1:
							i2=indeces[ii+1]
							if i2[1].lower()!=i[1].lower():
								k.append("mapTo("+i[1].lower()+"_"+i2[1].lower()+", X"+str(i[0])+", X"+str(i2[0])+", A"+str(i[0])+", A"+str(i2[0])+")")
							else:
								if i[1].lower()==domAbsPreds[0]:
									k.append("mapTo("+domAbsPreds[0]+"_"+domAbsPreds[1]+", X"+str(i[0])+", _, A"+str(i[0])+", _)")
									k.append("mapTo("+domAbsPreds[0]+"_"+domAbsPreds[1]+", X"+str(i2[0])+", _, A"+str(i2[0])+", _)")
								else:
									k.append("mapTo("+domAbsPreds[0]+"_"+domAbsPreds[1]+", _, X"+str(i[0])+", _, A"+str(i[0])+")")
									k.append("mapTo("+domAbsPreds[0]+"_"+domAbsPreds[1]+", _, X"+str(i2[0])+", _, A"+str(i2[0])+")")
							skipnext=True
						elif i[1].lower() in domAbsPreds and len(indeces)<=ii+1:
							if i[1].lower()==domAbsPreds[0]:
								k.append("mapTo("+i[1].lower()+"_"+domAbsPreds[1]+", X"+str(i[0])+", X"+domAbsPreds[1].upper()+", A"+str(i[0])+", A"+domAbsPreds[1].upper()+")")
							else:
								k.append("mapTo("+domAbsPreds[0]+"_"+i[1].lower()+", X"+domAbsPreds[0].upper()+", X"+str(i[0])+", A"+domAbsPreds[0].upper()+", A"+str(i[0])+")")
						else:
							k.append("mapTo("+i[1].lower()+", X"+str(i[0])+", A"+str(i[0])+")")
					k=", ".join(k)
					text=text+k+"."
				else:
					text=atemp+":-"+"_"+atemp+"."
				absfactstext=absfactstext+text+"\n"
		
		for a in self.factPreds:
			absfactstext=absfactstext+"_"+self.getAtom(a)[0].replace("MINUS","-")+".\n"
		text=""
		for a in self.atomList:
			if "neg" in a or "-" in a or "placeholder" in a: # or "aux_first" in a or "aux_second" in a:
				continue
			if "#show "+a not in text:
				arglength=len(a.split(","))
				atemp=a
				atemp=atemp.replace("choice_","")
				#print atemp
				if "(" in atemp:
					text=text+"#show "+atemp[:atemp.index("(")]+"/"+str(arglength)+".\n"
				else:
					text=text+"#show "+atemp+"/0.\n"
		absfactstext=absfactstext+text
		return absfactstext

	def checkCyclicDependencies(self):
		for a in self.rules:
			#FIXME for now assuming head has one atom!
			rule1head=self.getHead(a)[0]
			if rule1head==[]:
				continue
			rule1headpred=self.getPred(rule1head)
			for b in self.negbody:
				rule2negbodypred=self.getPred(b[1])
				if rule1headpred==rule2negbodypred:
					rule2head=self.getHead(b[0])[0]
					if rule2head==[]:
						continue
					rule2headpred=self.getPred(rule2head)
					if [rule1headpred,rule2headpred] in self.cyclicDep or [rule2headpred,rule1headpred] in self.cyclicDep:
						continue
					for c in self.negbody:
						rule3negbodypred2=self.getPred(c[1])							
						rule3head=self.getHead(c[0])[0]
						if rule3head==[]:
							continue
						if rule2headpred==rule3negbodypred2 and rule1headpred==self.getPred(rule3head):
							#print "cyclic dependency!! "+rule1headpred+" - "+rule2headpred
							self.cyclicDep.append([rule1headpred,rule2headpred])

		

def checkIfRelAndGetVars(m,p):
	return [[k[2],k[3]] for k in m.predRelVar if k[0]==p]


def checkIfRelAndGetVarsNonBin(m,p):
	gatherall1 = [[k[2],k[3],k[4],k[5]] for k in m.predRelVarNonBin if k[0]==p and len(k)==6]
	gatherall2 = [[k[2],k[3],k[4]] for k in m.predRelVarNonBin if k[0]==p and len(k)==5]
	return gatherall1 + gatherall2

def makeNewNonGroundRule(m,r,l,ruletype):
	#FIXME for now assuming head has one atom!
	h = m.getHead(r)[0]
	if h==[]:
		if ruletype=="0b" or ruletype=="1b" or ruletype=="3b" or ruletype=="3ab" or ruletype=="3c":
			return ""
		else:
			head=""
	else:
		if ruletype=="0b" or ruletype=="1b" or ruletype=="3b" or ruletype=="3ab" or ruletype=="3c":
			head="{"+m.getAtom(h)[0]+"}"
		else:
			head=m.getAtom(h)[0]

	posbodytemp=m.getPosbody(r)
	ptext=[]
	moretemppos=[]
	#print "----at moretemppos----"
	firstrelvarlength=0
	secondrelshorter=False
	for p in posbodytemp:
		haverel=False
		ptemp=m.getAtom(p)[0]
		alreadypaired={}
		#if rule has a relation 
		if "0" not in ruletype:
			relvars=checkIfRelAndGetVars(m,p)
			if relvars==[]:
				relvars=checkIfRelAndGetVarsNonBin(m,p)
			if relvars!=[]:
				haverel=True
				checkoutput=m.checkIfRelatedWithAbsPred(r,p)
				relusedforabs=False
				#print checkoutput
				if "True" in checkoutput:#FIXME Jan 17'19 - got rid of following restriction, do i need it? "and m.hasConstant(p)==False:"
					relusedforabs=True
					if moretemppos!=[]:
						addothervar=True
						if len(relvars[0])<firstrelvarlength:
							secondrelshorter=True    
					else:
						addothervar=False
						firstrelvarlength=len(relvars[0])
					for i in range(0,len(relvars[0])):
						if re.match("[A-Z]",relvars[0][i])!=None:
							#didnt need to make use of checkoutput[2] which returns the domabspred index of the variable
							if addothervar==False:
								moretemppos.append(relvars[0][i])
							else:
								pairedwith=m.checkWhichVarPairExistsInRule(r,relvars[0][i])
								if pairedwith==[]:
									realpair=m.getVarPairFromDomAbsPredOrder(r,relvars[0][i])
									index=[zz for zz in range(0,len(moretemppos)) if moretemppos[zz]==realpair]
									if index!=[]:
										moretemppos.insert(index[0]+1,relvars[0][i])
									else:    
										moretemppos+=[realpair,relvars[0][i]]
								for z in pairedwith:
									isreallypairedwitharelvar=[zz for zz in range(0,len(moretemppos)) if moretemppos[zz]==z]
									if isreallypairedwitharelvar!=[]:
										index=[zz for zz in range(0,len(moretemppos)) if moretemppos[zz]==z][0]
										if alreadypaired.has_key(moretemppos[index])==False:
											moretemppos.insert(index+1,relvars[0][i])
											alreadypaired[moretemppos[index]]=True
										else:
											moretemppos.insert(index+2,moretemppos[index])
											moretemppos.insert(index+3,relvars[0][i])
									else:
										#print "that wasnt the real pair - searching for the real pair through the dom abs pred order in the rule"
										realpair=m.getVarPairFromDomAbsPredOrder(r,relvars[0][i])
										#print "real pair is: "+realpair
										#Jan 17'19 - find the index of the real pair
										index=[zz for zz in range(0,len(moretemppos)) if moretemppos[zz]==realpair]
										if index!=[]:
											moretemppos.insert(index[0]+1,relvars[0][i])
										else:    
											moretemppos+=[realpair,relvars[0][i]]
					if secondrelshorter==True:
						moretemppos=m.fillRemainingVarsWithPairs(r,moretemppos)    
		if ruletype!="00":
			ptemp=m.ifHasConstantMakeAbstract(p,ptemp)
		#dont want to put the rel atom in the abs rule
		# Jan 19'19 - fixed, it was omitting rels not involved in dom abs
		if haverel==True and relusedforabs==True:
			continue
		else:
			ptext.append(ptemp)
	ptext=", ".join(ptext)
	negbodytemp=m.getNegbody(r)
	ntext=[]
	removed=False
	moretempneg=[]
	#print "----at moretempneg----"
	for n in negbodytemp:
		ntemp=m.getAtom(n)[0]
		if ruletype!="00":
			ntemp=m.ifHasConstantMakeAbstract(n,ntemp)
		if ruletype=="00" or ruletype=="0a" or ruletype=="3a" or ruletype=="3ab" or ruletype=="3b" or ruletype=="1a":
			ntext.append("not "+ntemp)
		else:
			if isCyclicDependant(m,h,n)==False:
				checkoutput=m.checkIfRelatedWithAbsPred(r,n)
				if "True" in checkoutput and m.hasConstant(n)==False:
					[tr,varss,ind]=checkoutput
					for i in range(0,len(varss)):
						varss[i]=varss[i].replace("v","")
						if re.match("[A-Z]",varss[i])!=None:
							moretempneg.append(varss[i])
				ntext.append(ntemp)	
			else:
				removed=True			
	ntext=", ".join(ntext)
	if ptext!="":
		text=head+" :- "+ptext
		if ntext!="":
			text=text+", "+ntext+".\n"
		else:
			text=text+".\n"
	else:
		if ntext!="":
			text=head+" :- "+ntext+".\n"
		else:
			text=head+".\n"

	if moretemppos!=[]:
		relatom=",".join(moretemppos)
		if "1" in ruletype:
			relatom="rel"+r+"("+relatom+",i)"
		elif "3" in ruletype:
			relatom="rel"+r+"("+relatom+",iii)"
		text=text.replace(".\n",", "+relatom+".\n")
		if ruletype=="3a":
			singatom=[]
			for i in moretemppos:
				if i+")" not in head and i+"," not in head:
					singatom.append("isSingleton("+i+")")
			singatom=",".join(singatom)
			text=text.replace(".\n",", "+singatom+".\n")
		elif ruletype=="3ab":
			clatom=[]
			for i in moretemppos:
				if i+")" not in head and i+"," not in head:
					clatom.append("isCluster("+i+")")	
			texttemp=text.replace(".\n",", "+clatom[0]+".\n")
			for i in range(1,len(clatom)):
				texttemp+=text.replace(".\n",", "+clatom[i]+".\n")
			text=texttemp
	else:
		print("rule "+r+" type is "+ruletype+" and moretemppos is empty")
	if moretempneg!=[]:
		if ruletype=="3c" or ruletype=="1b" or ruletype=="0b":
			clatom=[]
			for i in moretempneg:
				clatom.append("isCluster("+i+")")
			texttemp=text.replace(".\n",", "+clatom[0]+".\n")
			for i in range(1,len(clatom)):
				texttemp+=text.replace(".\n",", "+clatom[i]+".\n")
			text=texttemp
		else:
			print("rule "+r+" type is "+ruletype+" and moretempneg is NOT empty")
	else:		
		print("rule "+r+" type is "+ruletype+" and moretempneg is empty")
		if ruletype=="0b":
			text=""
	#FIXME is there also a need to do: if relinfo==[] and l!=[] and removed==False:  text="" WHY?
	
	return text


def isCyclicDependant(m,p1,p2):
	pred1=m.getPred(p1)
	pred2=m.getPred(p2)
	if [pred1,pred2] in m.cyclicDep or [pred2,pred1] in m.cyclicDep:
		return True
	return False

def saveRelsToComputeToFile(arr):
    global fileorg
    text=""
    for a in arr:
        text+=a[0]+" - "+" ".join(",".join(b) for b in a[1]) +" - "+" ".join(",".join(b) for b in a[2]) +"\n"
    fout=open(fileorg+"_relsToCompute.txt","w")
    fout.write(text)
    fout.close()
    

def readRelsToComputeFromFile():  
    fin=open(fileorg+"_relsToCompute.txt","r")
    text=fin.read()
    fin.close()
    arrget=re.findall(r"([^\n]*) - ([^\n]*) - ([^\n]*)\n",text)
    allarr=[]
    for arr in arrget:
        rname=arr[0]
        rrels=arr[1].split(" ")
        rvars=arr[2].split(" ")
        rrelsarr=[a.split(",") for a in rrels]
        rvarssarr=[a.split(",") for a in rvars]
        allarr+=[[rname, rrelsarr, rvarssarr] ]
    return allarr
    
    
def constructAbsRules(m):
	relsToCompute=[]
	absrules=""
	for r in m.rules:
		if r in m.facts:
			#print "rule "+r+" is a fact - moving on"
			continue	
		allrulerels=[k for k in m.ruleRel if k[0]==r]
		headShare=m.getRelShareHead(r)

		notusedrels=[]
		for rulerelinfo in allrulerels:
			rulerel=rulerelinfo[2]
			if rulerel=="none":
				continue
			elif "False" in m.checkIfRelatedWithAbsPred(r,rulerelinfo[1]):
				notusedrels.append(rulerelinfo)
								

		#if norel ---> keepsamerule
		if allrulerels[0][2]=="none":
			absrules=absrules+"%rule "+r+": type 0a\n"
			absrules=absrules+makeNewNonGroundRule(m,r,[],"0a")
			absrules=absrules+"%rule "+r+": type 0b\n"
			absrules=absrules+makeNewNonGroundRule(m,r,[],"0b")
			continue

		#for rels not sharing with abs dom & no other used rel exists:	
		for rulerelinfo in notusedrels:
			hasAnotherUsedRel=False
			for i in allrulerels:
				if "True" in m.checkIfRelatedWithAbsPred(r,i[1]):
					hasAnotherUsedRel=True
					break
			if hasAnotherUsedRel==False:
				absrules=absrules+"%rule "+r+": type 00\n"
				absrules=absrules+makeNewNonGroundRule(m,r,[],"00")
				absrules=absrules+"%rule "+r+": type 0b\n"
				absrules=absrules+makeNewNonGroundRule(m,r,[],"0b")
			else:
				absrules=absrules+"%rule "+r+": not sharing var with abs dom + but has another used rel - do nothing\n"

		usedrels=[rr for rr in allrulerels if rr not in notusedrels]
		if usedrels==[]:
			continue
		#print "getting used vars"
		usedvars=[]
		for x in usedrels:
			#print m.checkIfRelatedWithAbsPred(r,x[1])
			usedvars.append(m.checkIfRelatedWithAbsPred(r,x[1])[1])

		relsToCompute.append([r,usedrels,usedvars])
		saveRelsToComputeToFile(relsToCompute)
		

		absrules=absrules+"%rule "+r+": type 1a\n"
		absrules=absrules+makeNewNonGroundRule(m,r,[],"1a")

		splus=m.getSplusAll(r,usedrels)
		splus=list(set(splus))
		sminus=m.getSminusAll(r,usedrels)
		sminus=list(set(sminus))

		if splus+sminus!=[] and not m.headSharesVarWithS(headShare,splus+sminus):# and (m.getRelShareHeadIndex(r)!=[] and m.getRelShareHeadIndex(r)!=['none']):
			absrules=absrules+"%rule "+r+": type 3a\n"
			absrules=absrules+makeNewNonGroundRule(m,r,[],"3a")
			absrules=absrules+"%rule "+r+": type 3a-b\n"
			absrules=absrules+makeNewNonGroundRule(m,r,[],"3ab")
		else:
			absrules=absrules+"%rule "+r+": type 3b\n"
			absrules=absrules+makeNewNonGroundRule(m,r,[],"3b")
		
		rulesNegBody=m.getNegbody(r)
		if rulesNegBody!=[]:
			absrules=absrules+"%rule "+r+": type 1b\n"
			absrules=absrules+makeNewNonGroundRule(m,r,[],"1b")
			absrules=absrules+"%rule "+r+": type 3c\n"
			absrules=absrules+makeNewNonGroundRule(m,r,[],"3c")	
	#print absrules
	if not os.path.isfile(foldername+"computedreltypes/aux_reltypefacts_"+clustername+".lp"):
		allreltypes=computeCombinationAbsRelType(m,relsToCompute)
	else:
		copyfile(foldername+"computedreltypes/aux_reltypefacts_"+clustername+".lp","aux_reltypefacts.lp")
	#print allreltypes
	return absrules

def getRelSign(relpred):
	if relpred=="equ":
		relsign="="
	elif relpred=="neq":
		relsign="!="
	elif relpred=="less":
		relsign="<"
	elif relpred=="greater":
		relsign=">"
	elif relpred=="geq":
		relsign=">="
	elif relpred=="leq":
		relsign="<="
	else:
		print("ERR: something's wrong with rel sign")
		relsign="-1"
	return relsign

def computeCombinationAbsRelType(m,allrels):
	#FIXME Oct 10 - right now assuming at most two rels AND rel1 is about X,X1 while rel2 is about Y,Y1 - NEED TO BE made more generic
	#FIXME Oct 17 - now also considers them having 4 args - BUT does not consider the fact that there can be a lot more abs elts involved in the rel
	#				something like X=X1, Y1<Y2, .... is not caught here!
	allreltypes=[]
	projectrelfact=""
	repeatedrels=""
	alreadycomputedrels=[[],[]]
	for x in allrels:
		rule=x[0]
		rels=x[1]
		usedvars=x[2]
		rel1=rels[0]
		print x
		rel1arity=m.getArity(rel1[2])
		if len(rels)>1:
			rel2=rels[1]
			rel2arity=m.getArity(rel2[2])
			#FIXME this does not work great if there is same rel but with different variables 
			#        Jan 30'19 - a workaround would have to be modifying the relnames and distinguishing the relevant vars, e.g. equEqu3X, equEqu3Y
			#                    but for binary builtins like X!=X1, Y!=Y1, I cannot rename them!!!
			#                    so cant' use this...
			#if [rel1[2],rel1arity,rel2[2],rel2arity] in alreadycomputedrels[0]:
			#	repeatedrels+="rel"+rule+"("+",".join(["X"+str(i) for i in range(2*max(rel1arity,rel2arity))])+",I) :- rel"+alreadycomputedrels[1][alreadycomputedrels[0].index([rel1[2],rel1arity,rel2[2],rel2arity])]+"("+",".join(["X"+str(i) for i in range(2*max(rel1arity,rel2arity))])+",I).\n"
			#	continue
			#else:
			#	alreadycomputedrels[0]+=[[rel1[2],rel1arity,rel2[2],rel2arity]]
			#	alreadycomputedrels[1]+=[rule]
		else:
			rel2arity=0
			#if [rel1[2],rel1arity,0,0] in alreadycomputedrels[0]:
			#	repeatedrels+="rel"+rule+"("+",".join(["X"+str(i) for i in range(rel1arity)])+",I) :- rel"+alreadycomputedrels[1][alreadycomputedrels[0].index([rel1[2],rel1arity,0,0])]+"("+",".join(["X"+str(i) for i in range(rel1arity)])+",I).\n"
			#	continue
			#else:
			#	alreadycomputedrels[0]+=[[rel1[2],rel1arity,0,0]]
			#	alreadycomputedrels[1]+=[rule]
		text=""
		if rel1arity==2:
			if "X" in usedvars[0][0]:
				var1="X"
			elif "Y" in usedvars[0][0]:
				var1="Y"
			else:
				print("something's wrong with usedvars")
				var1="K"
			text=text+"orgrel1("+var1+"1,"+var1+"2) :- "
			if rel1[2] in m.knownBuiltinBinaryRels: 
				relsign=getRelSign(rel1[2])
				text=text+var1+"1"+relsign+var1+"2, dom(ABS,c(X1,Y1)), dom(ABS,c(X2,Y2)).\n"
			else:
				text=text+rel1[2]+"("+var1+"1,"+var1+"2), dom(ABS,c(X1,Y1)), dom(ABS,c(X2,Y2)).\n"
		elif rel1arity==3:
			if "X" in usedvars[0][0]:
				var1="X"
			elif "Y" in usedvars[0][0]:
				var1="Y"
			else:
				print("usedvars1 has different name then X or Y -> putting X")
				var1="X"
			text=text+"orgrel1("+var1+"1,"+var1+"2,"+var1+"3) :- "
			text=text+rel1[2]+"("+var1+"1,"+var1+"2,"+var1+"3), dom(ABS,c(X1,Y1)), dom(ABS,c(X2,Y2)), dom(ABS,c(X3,Y3)).\n"
		elif rel1arity==4:
			if "X" in usedvars[0][0]:
				var1="X"
			elif "Y" in usedvars[0][0]:
				var1="Y"
			else:
				print("something's wrong with usedvars")
				var1="K"
			text=text+"orgrel1("+var1+"1,"+var1+"2,"+var1+"3,"+var1+"4) :- "
			text=text+rel1[2]+"("+var1+"1,"+var1+"2,"+var1+"3,"+var1+"4), dom(ABS,c(X1,Y1)), dom(ABS,c(X2,Y2)), dom(ABS,c(X3,Y3)), dom(ABS,c(X4,Y4)).\n"
		if rel2arity==2:
			if "X" in usedvars[1][0]:
				var2="X"
			elif "Y" in usedvars[1][0]:
				var2="Y"
			else:
				print("something's wrong with usedvars")
				var2="K"
			text=text+"orgrel2("+var2+"1,"+var2+"2) :- "
			if rel2[2] in m.knownBuiltinBinaryRels: 
				relsign=getRelSign(rel2[2])
				text=text+var2+"1"+relsign+var2+"2, dom(ABS,c(X1,Y1)), dom(ABS,c(X2,Y2)).\n"
			else:
				text=text+rel2[2]+"("+var2+"1,"+var2+"2), dom(ABS,c(X1,Y1)), dom(ABS,c(X2,Y2)).\n"
		elif rel2arity==3:
			if "X" in usedvars[1][0]:
				var1="X"
			elif "Y" in usedvars[1][0]:
				var1="Y"
			else:
				print("usedvars2 has different name then X or Y -> putting Y")
				var1="Y"
			text=text+"orgrel2("+var1+"1,"+var1+"2,"+var1+"3) :- "
			text=text+rel2[2]+"("+var1+"1,"+var1+"2,"+var1+"3), dom(ABS,c(X1,Y1)), dom(ABS,c(X2,Y2)), dom(ABS,c(X3,Y3)).\n"
		elif rel2arity==4:
			if "X" in usedvars[1][0]:
				var2="X"
			elif "Y" in usedvars[1][0]:
				var2="Y"
			else:
				print("something's wrong with usedvars")
				var2="K"
			text=text+"orgrel2("+var2+"1,"+var2+"2,"+var2+"3,"+var2+"4) :- "
			text=text+rel2[2]+"("+var2+"1,"+var2+"2,"+var2+"3,"+var2+"4), dom(ABS,c(X1,Y1)), dom(ABS,c(X2,Y2)), dom(ABS,c(X3,Y3)), dom(ABS,c(X4,Y4)).\n"	
		#print text
		fout=open("aux_computereltype.lp","w")
		fout.write(text)
		fout.close()

		if rel2arity==0:
			callfile="computeRelType_pairs"+str(rel1arity)+var1+".lp"
		else:
			if rel1[2]=="equEqu4" and rel2[2]=="equEqu4":
				callfile="computeRelType_pairs"+str(rel1arity)+str(rel2arity)+"_equEqu.lp"
			else:
				callfile="computeRelType_pairs"+str(rel1arity)+str(rel2arity)+".lp"

		
		
		fout = open("reltypepairs.txt","w")
		p = pexpect.spawn("clingo reltype_computation/"+callfile+" aux_computereltype.lp "+mapping+" reltype_computation/aux_nonbinaryrelations.lp",timeout=600)
		p.logfile=fout
		a=p.expect([pexpect.EOF,'ERROR',pexpect.TIMEOUT])
		fout.close()
		if a == 1 or a==2: # Timeout
			print("Timeout or Error")
			sys.exit()
		fin=open("reltypepairs.txt","r")
		textrel=fin.read()
		fin.close()
		reltype=[]
		if rel1arity<=2 and rel2arity<=2:
			rell=re.findall(r"newrel\("+"_".join(domAbsPreds)+",\ *c\((\S+),(\S+)\),\ *c\((\S+),(\S+)\),\ *(\S+)\).",textrel)
			for rel in rell:
				reltype.append([rel[0],rel[1],rel[2],rel[3],rel[4]])
			if rel2arity==0:
				if var1=="Y":
					projectrelfact+="rel"+rule+"(Y1,Y2,I) :- rel"+rule+"(X1,Y1,X2,Y2,I).\n"
				elif var1=="X":
					projectrelfact+="rel"+rule+"(X1,X2,I) :- rel"+rule+"(X1,Y1,X2,Y2,I).\n"
		elif rel1arity<=3 and rel2arity<=3:
			rell=re.findall(r"newrel\("+"_".join(domAbsPreds)+",\ *c\((\S+),(\S+)\),\ *c\((\S+),(\S+)\),\ *c\((\S+),(\S+)\),\ *(\S+)\).",textrel)
			for rel in rell:
				reltype.append([rel[0],rel[1],rel[2],rel[3],rel[4],rel[5],rel[6]])
			if rel2arity==0:
				if var1=="Y":
					projectrelfact+="rel"+rule+"(Y1,Y2,Y3,I) :- rel"+rule+"(X1,Y1,X2,Y2,X3,Y3,I).\n"
				elif var1=="X":
					projectrelfact+="rel"+rule+"(X1,X2,X3,I) :- rel"+rule+"(X1,Y1,X2,Y2,X3,Y3,I).\n"
		elif rel1arity<=4 and rel2arity<=4:
			rell=re.findall(r"newrel\("+"_".join(domAbsPreds)+",\ *c\((\S+),(\S+)\),\ *c\((\S+),(\S+)\),\ *c\((\S+),(\S+)\),\ *c\((\S+),(\S+)\),\ *(\S+)\).",textrel)
			for rel in rell:
				reltype.append([rel[0],rel[1],rel[2],rel[3],rel[4],rel[5],rel[6],rel[7],rel[8]])
			if rel2arity==0:
				if var1=="Y":
					projectrelfact+="rel"+rule+"(Y1,Y2,Y3,Y4,I) :- rel"+rule+"(X1,Y1,X2,Y2,X3,Y3,X4,Y4,I).\n"
				elif var1=="X":
					projectrelfact+="rel"+rule+"(X1,X2,X3,X4,I) :- rel"+rule+"(X1,Y1,X2,Y2,X3,Y3,X4,Y4,I).\n"
		allreltypes.append(["rel"+rule,reltype])
	text=""
	for x in allreltypes:
		for y in x[1]:
			line=x[0]+"("
			args=[]
			for i in range(0,len(y)):
				args.append(y[i])
			line+=",".join(args)+").\n"
			text+=line
	
	fout=open(foldername+"computedreltypes/aux_reltypefacts_"+clustername+".lp","w")
	fout.write(text+projectrelfact+repeatedrels)
	fout.close()
	copyfile(foldername+"computedreltypes/aux_reltypefacts_"+clustername+".lp","aux_reltypefacts.lp")
	
	return allreltypes

def preProcessRangeAndTimeAndChoice(text):
	#FIXME what if there is a(1..n) ????
	#FIXME or what if there is a(1..3,red).????
	dots=re.findall(r"(%*\w+)\((\d+)\.\.(\d+)\).",text)
	twodots=re.findall(r"(%*\w+)\((\d+)\.\.(\d+)\,(\d+)\.\.(\d+)\).",text)
	onedots=re.findall(r"(%*\w+)\((\d+)\.\.(\d+)\,(\d+)\).",text)
	changed=False
	for a in dots:
		if "%" in a[0]:
			continue
		text=text.replace(a[0]+"("+a[1]+".."+a[2]+").", "")
		for i in range(int(a[1]),int(a[2])+1):
			text=text+a[0]+"("+str(i)+")."
		text=text+"\n"
		changed=True
	for a in twodots:
		if "%" in a[0]:
			continue
		text=text.replace(a[0]+"("+a[1]+".."+a[2]+","+a[3]+".."+a[4]+").", "")
		for i in range(int(a[1]),int(a[2])+1):
			for j in range(int(a[3]),int(a[4])+1):
				text=text+a[0]+"("+str(i)+","+str(j)+")."
		text=text+"\n"
		changed=True
	for a in onedots:
		if "%" in a[0]:
			continue
		text=text.replace(a[0]+"("+a[1]+".."+a[2]+","+a[3]+").", "")
		for i in range(int(a[1]),int(a[2])+1):
			text=text+a[0]+"("+str(i)+","+a[3]+")."
		text=text+"\n"
		changed=True
	
	text=re.sub(r'T\-1',r'TMINUS1',text)
	text=re.sub(r'T\+1',r'TPLUS1',text)
	text=re.sub(r'([A-Za-z0-9]+) *= *([A-Za-z0-9]+) *- *([A-Za-z0-9]+)',r'minus(\1,\2,\3)',text)
	text=re.sub(r'([A-Za-z0-9]+) *= *([A-Za-z0-9]+) *\+ *([A-Za-z0-9]+)',r'plus(\1,\2,\3)',text)
	text=re.sub(r'([^:])-',r'\1MINUS',text)
	textchoices=re.findall(r"(%*(\d*)\{(.*)\}(\d*)(.*:-.*.))",text)
	textkeepchoices=[]
	if textchoices!=[]:
		gatherchoicestemp=[k for k in textchoices if k[0][0]!="%" and k[1]!='' and (":" in k[2] or ";" in k[2])]
		#DEC 13 : also added below to get the choice rules "{a(X) : b(X)}1" 
		gatherchoicestemp+=[k for k in textchoices if k[0][0]!="%" and k[1]=='' and (":" in k[2] or ";" in k[2])]
		#FEB 1 : also added below to get the choice rules "{a(X)}1" 
		gatherchoicestemp+=[k for k in textchoices if k[0][0]!="%" and k[1]=='' and k[3]!='' and ":" not in k[2]]
		#FEB 1 : also added below to get the choice rules "1{a(X)}1" 
		gatherchoicestemp+=[k for k in textchoices if k[0][0]!="%" and k[1]!='' and k[3]!='' and ":" not in k[2]]
		textkeepchoices=[k for k in textchoices if k[0][0]!="%" and k[1]=='' and k[3]=='' and ":" not in k[2] and ";" not in k[2]]
		textchoices=list(set(gatherchoicestemp))
		
	
	texttemp=re.sub(r'(\d*\{.*\}\d*.*:-.*.)', r'',text)

	for k in textkeepchoices:
		texttemp=texttemp+"\nchoice_"+k[2]+k[4]+"\n"
	if textkeepchoices!=[] and textchoices==[]:
		textchoices=["-"]
	elif textchoices!=[]:
		fout=open("aux_choice_placeholders.txt","w")
		for a in range(0,len(textchoices)):
			texttemp=texttemp+"choiceplaceholder_"+str(a)+textchoices[a][4]+"\n"
			fout.write("choiceplaceholder_"+str(a)+" = "+textchoices[a][1]+'{'+textchoices[a][2]+'}'+textchoices[a][3])
		fout.close()
	if texttemp!=text:
		changed=True
	text=texttemp
	text=re.sub(r'(#show .*)', r'%\1',text)
	return [text,changed,textchoices]

def postProcessChoice(text,textchoices,abstractedAtoms):
	if textchoices!=["-"]:
		for a in range(0,len(textchoices)):
			#FIXME right now replaces all the placeholders with the original choice head - no limit is changed
			text=re.sub(r'\{choiceplaceholder_'+str(a)+'\}(.*:-.*.)', textchoices[a][1]+'{'+textchoices[a][2]+'}'+textchoices[a][3]+r'\1',text)
			text=re.sub(r'choiceplaceholder_'+str(a)+'( :-.*.)', textchoices[a][1]+'{'+textchoices[a][2]+'}'+textchoices[a][3]+r'\1',text)
	text=re.sub(r'\{choice\_(.*)\}(.*:-.*.)', r'{\1}\2',text)
	text=re.sub(r'choice\_(.*)(.*:-.*.)', r'{\1}\2',text)
	return text

def postProcessMakeObjName(lines,objname):
	newlines=""
	for line in lines:
		atoms=re.findall(r"((\w+)\((\S*)\))",line)
		replaceatoms=[[] for i in range(len(atoms))]
		processedvars=[]
		for a in atoms:
			varsplit=a[2].split(",")
			if len(varsplit)==1:
				continue
			for i in range(0,len(varsplit)):
				for b in atoms:
					if b[1]==domAbsPreds[0] and b[2]==varsplit[i] and len(varsplit)>i+1 and [z for z in atoms if z[2]==varsplit[i+1] and z[1]==domAbsPreds[1]]!=[]:
						if varsplit[i] not in processedvars:
							processedvars.append(varsplit[i])
						if varsplit[i+1] not in processedvars:
							processedvars.append(varsplit[i+1])
						newobj=objname+"("+varsplit[i]+","+varsplit[i+1]+")"	
						replaceatoms[atoms.index(a)].append(newobj)
						if newobj in line:
							continue
						if b[0] in line:
							line=line.replace(b[0],newobj)
						else:
							line=line.replace(objname,newobj+", "+objname,1)
						break
		for b in atoms:
			if b[1] in domAbsPreds:
				if b[2] in processedvars:
					#Jan 17'19 - FIXME this is a horrible way of gettin rid of dom preds in the rule    
					linetemp=line.replace(", "+b[0],"")
					linetemp=linetemp.replace(","+b[0],"")
					if linetemp==line:
						linetemp=line.replace(b[0]+",","")
						linetemp=linetemp.replace(b[0]+" ,","")  
					line=linetemp
				else:
					if atoms.index(b)+1==len(atoms):
						continue
					nextatom=atoms[atoms.index(b)+1]
					if nextatom[1] in domAbsPreds and nextatom[2] not in processedvars:
						line=line.replace(b[0]+", "+nextatom[0],objname+"("+b[2]+","+nextatom[2]+")")   
					else:
						print(line)
						print(b)
						print("cant make objname for "+b[2])
		newlines+=line
	return newlines
	
def createAbsCheckRules(atomlist, interestedatoms,interestedelts):
	text=""
	for a in atomlist:
		if "neg" in a  or "-" in a  or "placeholder" in a or "aux" in a or "passed" in a or "conn" in a:# or "aux_second" in a or "aux_first" in a:
			continue
		if interestedatoms!=[] and (("(" in a and a[:a.index("(")] not in interestedatoms) or ("(" not in a and a not in interestedatoms)):
			continue
		if "("+a not in text:
			indeces=re.findall(r"X(([A-Z]*)\d+)",a)
			k=[]
			kk=[]
			a=a.replace("TPLUS1","T+1")
			a=a.replace("TMINUS1","T-1")
			a=a.replace("choice_","")
			if indeces!=[]:
				skipnext=False
				skipatom=False
				for ii in range(0,len(indeces)):
					if skipnext==True:
						skipnext=False
						continue
					i=indeces[ii]
					if i[1].lower() in domAbsPreds and len(indeces)>ii+1:
						i2=indeces[ii+1]
						k.append("mapTo("+i[1].lower()+"_"+i2[1].lower()+", X"+str(i[0])+", X"+str(i2[0])+", A"+str(i[0])+", A"+str(i2[0])+")")
						kk.append("care(A"+str(i[0])+", A"+str(i2[0])+")")
						skipnext=True
					elif i[1].lower() in domAbsPreds and len(indeces)<=ii+1:
						#if the atom is related with one of the domabspred but the other arg of the pair is not in the atom
						#then it is skipped. e.g., having row(X), column(Y) separately. 
						#FIXME of course this also assumes there are NO atoms that take arguments only from one of the paired elements, e.g., notborder(X).
						skipatom=True				
					else:
						k.append("mapTo("+i[1].lower()+", X"+str(i[0])+", A"+str(i[0])+")")
						kk.append("care(A"+str(i[0])+")")
				if skipatom==True:
					continue
				k=", ".join(k)
				kk=", ".join(kk)
				if interestedelts!=[]:                    
					text=text+":- not absexists("+re.sub(r'([^A-Z])X',r'\1A',a)+"), "+a+", "+k+", "+kk+".\n"
					text=text+":- absexists("+re.sub(r'([^A-Z])X',r'\1A',a)+"), {"+a+": "+k+"}0, "+kk+".\n"
				else:
					text=text+":- not absexists("+re.sub(r'([^A-Z])X',r'\1A',a)+"), "+a+", "+k+".\n"
					text=text+":- absexists("+re.sub(r'([^A-Z])X',r'\1A',a)+"), {"+a+": "+k+"}0.\n"
					
			else:
				text=text+":- not absexists("+a+"), "+a+".\n"
				text=text+":- absexists("+a+"), {"+a+"}0.\n"

	if interestedelts!=[]:
		for i in interestedelts:
			text=text+"_care("+str(i)+").\n"
		text=text+"care(A) :- _care(X), mapTo(_,X,A).\n"
				
	return text



def getAbsInfo(mapping):
	domabspred="_".join(domAbsPreds)
	fout = open("absinfo.txt","w")
	p = pexpect.spawn("clingo reltype_computation/absinfo_computation.lp "+mapping+" --outf=1",timeout=600)
	p.logfile=fout
	a=p.expect([pexpect.EOF,'ERROR',pexpect.TIMEOUT])
	fout.close()
	if a == 1 or a==2: # Timeout
		print("Timeout or Error")
		sys.exit()
	fin=open("absinfo.txt","r")
	textrel=fin.read()
	fin.close()
	cluster=re.findall(r"isCluster\("+domabspred+",\ *(\S+)\).",textrel)
	unique=re.findall(r"isSingleton\("+domabspred+",\ *(\S+)\).",textrel)
	mappiing=re.findall(r"mapTo\("+domabspred+",\ *(\S+),\ *(\S+),\ *(\S+),\ *(\S+)\).",textrel)
	
	text=""
	if metaobj==False:
		for i in cluster:
			text+="isCluster("+i+").\n"
		for i in unique:
			text+="isSingleton("+i+").\n"
		fout=open("aux_absregionfacts.lp","w")
		fout.write(text)
		fout.close()
	else:
		for i in cluster:
			text+="isIncCluster("+i+").\n"
		for i in unique:
			text+="isIncSingleton("+i+").\n"
		fout=open("aux_absregionfacts_inc.lp","w")
		fout.write(text)
		fout.close()

	absInfo=[mappiing, cluster , unique]
	return absInfo	
	

#input needs to be the MetaTranslator output of the program
fileorg=sys.argv[1]
mapping=sys.argv[2]

#get as input the atom that dom abs is being done, then add this to specialPred
domabspredicates=sys.argv[3]
domabspredicates=domabspredicates.split(",")


interestedatoms=[]

firsttime=True
metaobj=False

if len(sys.argv) ==5:
    if "--firsttime=False" in sys.argv[4]:
        firsttime=False
    elif "--metaobj=True" in sys.argv[4]:
        metaobj=True
    else:      
        interestedatoms=sys.argv[4]
        interestedatoms=interestedatoms.split(",")
print(interestedatoms)

interestedelts=[]

if len(sys.argv) ==6:    
    if "--firsttime=False" in sys.argv[5]:
        firsttime=False
    elif "--metaobj=True" in sys.argv[5]:
        metaobj=True
    else:    
        interestedelts=sys.argv[5]
        interestedelts=interestedelts.split(",")
        



fin=open(fileorg,"r")
textOrg=fin.read()
fin.close()


domAbsPreds=domabspredicates
	
fileorg=fileorg.replace("meta","next")

specialPred=[]

absInfo=getAbsInfo(mapping)
#print absInfo

clustername="-".join(sorted([",".join(bb) for bb in list(set([(aa[2],aa[3]) for aa in absInfo[0] if aa[2].count("a")>1 or aa[3].count("b")>1]))]))
foldername=fileorg[:fileorg.rfind("/")+1]

for domabspred in domAbsPreds:
	specialPred.append(domabspred)
	
#check if input is metatranslator output
if "#maxint" not in textOrg:    
    if firsttime==False:
        if os.path.isfile(fileorg+"_input")==True:
            fileorg=fileorg+"_input_meta"
        else:
            fileorg=fileorg+"_meta"
    else:
        [textNew,changed,textchoices]=preProcessRangeAndTimeAndChoice(textOrg)
        if changed==True:
            fileorg=fileorg+"_input"
            fout=open(fileorg,"w")
            fout.write(textNew)
            fout.close()
        if "{}" not in textOrg:
            os.system("java -jar MetaTranslator.jar "+fileorg+" aux_curlybrackets.lp > "+fileorg+"_meta")
        else:
            os.system("java -jar MetaTranslator.jar "+fileorg+" > "+fileorg+"_meta")
        #if not, translate it to the meta form
        fileorg=fileorg+"_meta"
    if metaobj==True:
        fileorg=fileorg.replace("_abs_objname_input","")    
    fin=open(fileorg,"r")
    textOrg=fin.read()
    fin.close()





m=meta(textOrg,specialPred,domAbsPreds, absInfo)
m.initializeAtoms()
#m.printout()

print clustername

if firsttime==False or metaobj==True:
	if not os.path.isfile(foldername+"computedreltypes/aux_reltypefacts_"+clustername+".lp"):
		relsToCompute=readRelsToComputeFromFile()
		print relsToCompute
		allreltypes=computeCombinationAbsRelType(m,relsToCompute)
	else:
		copyfile(foldername+"computedreltypes/aux_reltypefacts_"+clustername+".lp","aux_reltypefacts.lp")
		print foldername+"computedreltypes/aux_reltypefacts_"+clustername+".lp"
		print "copied "
	sys.exit()


m.checkCyclicDependencies()

	

absfactconversiontext = m.processFactsToAbstractFacts()
fileorgabs=fileorg.replace("meta","absfacts")
fout=open(fileorgabs,"w")
fout.write(absfactconversiontext)
fout.close()

checkrules=createAbsCheckRules(m.atomList,interestedatoms,interestedelts)
fileorgcheck=fileorg.replace("meta","checkrules")
fout=open(fileorgcheck,"w")
fout.write(checkrules)
fout.close()


#print "----Starting Construction----"
absrules=constructAbsRules(m)
name=fileorg.replace("meta","abs")
fout=open(name,"w")
if textchoices!=[]:		
	absrules=postProcessChoice(absrules,textchoices, m.abstractedAtoms)
fout.write(absrules)
fout.close()

textOrg=absrules

with open(name) as f:
	lines=f.readlines()
f.close()


fout=open(name+"_objname","w")
ruleswithobj=postProcessMakeObjName(lines,"cell")
fout.write(ruleswithobj)
fout.close()




