#Feb 14'19 
#Author : Zeynep G. Saribatur


import re
import pexpect
import time
import sys
import csv
import string
import os

class meta:
	def __init__(self,textOrg):
		self.rules=re.findall(r"rule\((\S+)\).",textOrg)
		self.head=re.findall(r"head\((\S+),\ *(\S+)\).",textOrg)
		self.negbody=re.findall(r"negbody\((\S+),\ *(\S+)\).",textOrg)
		self.posbody=re.findall(r"posbody\((\S+),\ *(\S+)\).",textOrg)
		self.pred=re.findall(r"pred\((\S+),\ *(\S+)\).",textOrg)
		self.struct=re.findall(r"struct\((\S+),\ *(\d+),\ *(\S+),\ *(\S+)\).",textOrg)
		self.arity=re.findall(r"arity\((\S+),\ *(\d+)\).",textOrg)
		self.apAtoms=[]
		self.blAtoms=[]
		self.atoms=[]
		self.predList=[]
		self.facts=[]
		self.factPreds=[]
		
	def initializeAtoms(self):
		self.getFacts()
		for r in self.rules:
			h = m.getHead(r)[0]
			#FIXME putting arguments of the head to "ap", but what if head=falsum?
			textAp="ap("+r+","
                
			if h!=[] and self.getArity(self.getPredName(h)[0])>0:
				for arg in self.getArgs(h):
					if re.search('v[A-Z]', arg)!=None:
						arg=arg.replace("v","")
					if arg=="TPLUS1":
						arg="T+1"
					elif arg=="TMINUS1":
						arg="T-1"
					elif "MINUS" in arg:
						arg=arg.replace('MINUS','-')
					textAp=textAp+arg+","
				textAp=textAp[:len(textAp)-1]+")"
				self.apAtoms.append([r,textAp])
				textBl=textAp.replace("ap","bl")
				self.blAtoms.append([r,textBl])
			elif self.getPosbody(r)!=[] or self.getNegbody(r)!=[]:
				posb=self.getPosbody(r)
				if posb!=[]:
					collectargs=[]
					for p in posb:
						argp=self.getArgs(p)
						if len(argp)==1 and argp[0].replace("v","") not in collectargs:
							arg=argp[0]
							if arg=="TPLUS1":
								arg="T+1"
							elif arg=="TMINUS1":
								arg="T-1"
							elif "MINUS" in arg:
								arg=arg.replace('MINUS','-')
							collectargs.append(arg.replace("v",""))
							textAp=textAp+arg.replace("v","")+","
						elif h==[] and obj==True and objname==m.getPredName(p)[0]:
							for z in argp:								
								collectargs.append(z.replace("v",""))
								textAp=textAp+z.replace("v","")+","
				textAp=textAp[:len(textAp)-1]+")"
				self.apAtoms.append([r,textAp])
				textBl="bl("+r+")"
				self.blAtoms.append([r,textBl])
		for pr in self.pred:
			if pr[1]=="equ" or pr[1]=="neq" or pr[1]=="less"  or pr[1]=="geq" or pr[1]=="greater" or pr[1]=="leq":
				var1=""
				var2=""
			elif "choiceplaceholder" in pr[1]:
				fin=open("aux_choice_placeholders.txt","r")
				auxplaceholders=fin.read()
				fin.close()
				choice=re.findall(pr[1]+" = (.*)",auxplaceholders)[0]
				textAtom=choice
			elif "choice_" in pr[1]:
				textAtom="{"+pr[1].replace("choice_","")
				textAtom=textAtom.replace('MINUS','-')
			elif "MINUS" in pr[1]:
				textAtom=pr[1].replace('MINUS','-')
			else:
				textAtom=pr[1]
            
			argtemp=m.getArgs(pr[0])
			if argtemp!=[]:
				textAtom+="("
				index=1
				for ii in range(0,len(argtemp)):
					arg=argtemp[ii]			
					if re.search('v[A-Z]', arg)!=None:
						arg=arg.replace("v","")
					#FIXME this is to deal with replaced time variables - make it better 
					if arg=="TPLUS1":
						arg="T+1"
					elif arg=="TMINUS1":
						arg="T-1"
					elif "MINUS" in arg:
						arg=arg.replace('MINUS','-')
					if  pr[1]=="equ" or pr[1]=="neq" or pr[1]=="less" or pr[1]=="greater" or pr[1]=="geq" or pr[1]=="leq":
						if var1=="":
							var1=arg
						else:
							var2=arg
							if pr[1]=="equ":
								textAtom=var1+"="+var2
							elif pr[1]=="neq":
								textAtom=var1+"!="+var2
							elif pr[1]=="less":
								textAtom=var1+"<"+var2
							elif pr[1]=="greater":
								textAtom=var1+">"+var2
							elif pr[1]=="geq":
								textAtom=var1+">="+var2
							elif pr[1]=="leq":
								textAtom=var1+"<="+var2
					else:
						textAtom=textAtom+arg+","
						
				if pr[1]!="equ" and pr[1]!="neq" and pr[1]!="less" and pr[1]!="geq" and pr[1]!="greater" and pr[1]!="leq":# and "plus" not in pr[1]:
						textAtom=textAtom[:len(textAtom)-1]+")"	
			if "choice_" in pr[1]:
				textAtom+="}"
			self.atoms.append([pr[0],textAtom])
		for ar in self.arity:
			self.predList.append(ar[0])

	def printout(self):
		#print self.changedRules
		#print self.omittedPreds
		#print self.rules
		#print self.head
		#print self.negbody
		#print self.posbody
		#print self.pred
		#print self.struct
		#print self.arity
		print "initialized"
		print self.apAtoms
		print self.blAtoms
		print self.atoms
	
	def getPred(self,p): 
		return [a[1] for a in self.pred if a[0]==p][0]
	def getHead(self,r):
		head=[a[1] for a in self.head if a[0]==r] 
		if head!=[]:
			return head
		else:
			return [[]]
	def getPosbody(self,r):
		return [a[1] for a in self.posbody if a[0]==r] 
	def getNegbody(self,r):
		return [a[1] for a in self.negbody if a[0]==r] 
	def getArity(self,p):
		return int([a[1] for a in self.arity if a[0]==p][0])
	def getArgs(self,p):
		return [a[3] for a in self.struct if a[0]==p] 
	def getType(self,p):
		return [a[2] for a in self.struct if a[0]==p][0] 
	def getPredSym(self,p):
		return [a[0] for a in self.pred if a[1]==p]
	def getPredName(self,p):
		return [a[1] for a in self.pred if a[0]==p]
	
	
	def getAtom(self,r):
		return [a[1] for a in self.atoms if a[0]==r]
    
	def getFacts(self):
		for a in self.rules:
			if self.getPosbody(a)==[] and self.getNegbody(a)==[]:
				self.facts.append(a)
				#FIXME for now assuming head has one atom!
				self.factPreds.append(self.getHead(a)[0])   
		
		
	def getPredOfArg(self,r,arg):
		posbody=self.getPosbody(r)
		for p in posbody:
			temp=[k[3] for k in self.struct if k[0]==p]
			if [arg]==temp or ["v"+arg]==temp:
				ppred=self.getPred(p)
				return ppred
		return "NONE"


	def fixNonesWithObjName(self,r,text,head):
		posbody=self.getPosbody(r)
		for p in posbody:
			atom=self.getAtom(p)[0]
			if objname in atom:
				args=atom[atom.index("(")+1:atom.index(")")]
				if args in head:
					text=text.replace("NONE("+args.split(",")[0]+"),NONE("+args.split(",")[1]+")",atom)
					text=text.replace("isCluster("+args.split(",")[0]+"),NONE("+args.split(",")[1]+")",atom)
					text=text.replace("NONE("+args.split(",")[0]+"),isCluster("+args.split(",")[1]+")",atom)
		return text
    

def buildMainRules(m,outtext):
 	for r in m.rules:
		#FIXME for now assuming head has one atom!
		h = m.getHead(r)[0]
		if h in m.factPreds:
			outtext+=m.getAtom(h)[0]+".\n"
			continue
		if h!=[]:
			head1=m.getAtom(h)[0]
			text4=""
		else:
			head1="falsum"
			text4=":- falsum.\n"
		apatom=m.apAtoms[m.rules.index(r)][1]
		if h!=[] and "choiceplaceholder" in m.getPredName(h)[0]:
			getheadargs=re.findall(r"\S+\(([A-Za-z0-9,]+)\)",head1)
			for gindex in range(0,len(getheadargs)):
				g=getheadargs[gindex]
				g=g.split(",")
				for a in g:
					if ",".join(getheadargs[:gindex]+getheadargs[gindex+1:]).split(",").count(a)==0 and a not in apatom:    
						apatom=apatom.replace(")",","+a+")")   
		body1=apatom+", not ko("+r+").\n"
		text1=head1+" :- "+body1
		print text1
		outtext=outtext+text1
		head2=apatom
		posbodytemp = m.getPosbody(r)
		body2pos=[]
		if posbodytemp!=[]:
			for item in posbodytemp:
				bodyatom=m.getAtom(item)[0]
				if obj==True and "isCluster" in bodyatom:
					bodyatom=bodyatom.replace("isCluster","isIncCluster")
				body2pos.append(bodyatom)
		body2pos=','.join(body2pos)	
		negbodytemp = m.getNegbody(r)
		body2neg=[]
		if negbodytemp!=[]:
			for item in negbodytemp:
				body2neg.append("not "+m.getAtom(item)[0])
		body2neg=','.join(body2neg)
		text2=head2+" :- "+body2pos
		if body2pos!="" and body2neg!="":
			text2=text2+", "
		text2=text2+body2neg+".\n"
		print text2
		outtext=outtext+text2
		if h==[] or m.getArity(m.getPredName(h)[0])==0:
			outtext=outtext+"ap("+r+") :- "+head2+".\n"
			text3="bl("+r+") :- not ap("+r+").\n"
		else:
			text3=m.blAtoms[m.rules.index(r)][1]+" :- not "+head2
			#FIXME assuming ground vars dont have uppercase		
			text3a=[]
			if re.search('[A-Z]',head2)!=None:
				variables=re.findall(r"([A-Z]+[0-9]*)",head2)
				text3=text3+","
				for var in variables:
					dompred=m.getPredOfArg(r,var)
					text3a.append(dompred+"("+var+")")   
			text3=text3+",".join(text3a)+".\n"
			if obj==True:
				text3=m.fixNonesWithObjName(r,text3,head2)    
		text3a=[]	
		print text3
		outtext=outtext+text3
		outtext=outtext+text4
	print "-----------------------------"
	return outtext

		
def buildAbPRules(m,outtext):
    for r in m.rules:
        #FIXME for now assuming head has one atom!
        h = m.getHead(r)[0]
        if m.getAtom(h)==[]:
            text1="{ko("+r+")}.\n"
            ap=m.apAtoms[m.rules.index(r)][1]
            abphead="ab_deactivatedConstraint("+r+")"
            text2=abphead+" :- ko("+r+"), "+ap+".\n"
            weakcon=":~ "+abphead+". [1,"+r+"]\n"
            outtext=outtext+text1+text2+weakcon
            print text1+text2+weakcon
        elif h in m.factPreds or "choice" in m.getAtom(h)[0] or "{" in m.getAtom(h)[0]:
            continue
        else:
            text1="ko("+r+").\n"
            head=m.getAtom(h)[0]
            ap=m.apAtoms[m.rules.index(r)][1]
            text2="{"+head+"} :- "+ap+".\n"
            abphead="ab_deactivated("+r+")"
            weakcons=":~ "+abphead+". [1,"+r+"]\n"
            abphead=abphead+" :- "
            text3=abphead+ap+", not "+head+".\n"
            print text1+text2+text3+weakcons
            outtext=outtext+text1+text2+text3+weakcons
    return outtext+"#show ab_deactivated/1.\n#show ab_deactivatedConstraint/1.\n"
	
def buildAbCRules(m,outtext):
	for p in m.predList:
		#if "choice" in p or 
		# Feb 5'19 - if choice version of the atom was processed before dont process it again
		if "{" in p or "choiceplaceholder" in p  or "choice_"+p in m.predList[:m.predList.index(p)] or "conn" in p:
			continue
		syms=m.getPredSym(p)
		# Feb 5'19 - get all atoms involved in the choice head
		if "choice" in p:
			syms+=m.getPredSym(p.replace("choice_",""))
		syms=[sym for sym in syms if "h" in sym]
		text1head=""
		bodya1=[]	
		weakvar=""
		fact=[]
		for sym in syms:
			rulename=re.findall(r"(r\d+)h",sym)[0]
			if m.getPosbody(rulename)==[] and m.getNegbody(rulename)==[]:
				fact.append("fact("+m.getAtom(sym)[0]+").\n")
				continue
			if text1head=="":
				#FIXME hepsinin head i ayni sekilde assume
				head=m.getAtom(sym)[0]	
				if "{" in head: 
					head=head.replace("{","")    
					head=head.replace("}","")    
				text1head="{"+head+"} :- "
			if head.find("(")!=-1:
				bl="bl("+rulename+","+head[head.find("(")+1:head.find(")")]+")"
				weakvar=","+head[head.find("(")+1:head.find(")")]
			else:
				bl=m.blAtoms[m.rules.index(rulename)][1]
			bodya1.append(bl)
		if bodya1!=[]:
			text1body=",".join(bodya1)+".\n"	
			outtext=outtext+text1head+text1body
			text3="ab_activated("+head+") :- "+",".join(bodya1)+", "+head
			if fact!=[]:
				text3+=", not fact("+head+").\n"+"".join(fact)
			else:
				text3+=".\n"
			text4=":~ ab_activated("+head+"). "+"[1"+weakvar+"]\n"
			outtext=outtext+text3+text4
	return outtext+"#show ab_activated/1.\n"

def postProcessCellElts(text):
    cells=re.findall(r"x(\d+)y(\d+)",text)
    for a in cells:
        text=text.replace("x"+a[0]+"y"+a[1],"("+a[0]+","+a[1]+")")
    return text

#input needs to be the MetaTranslator output of the program
fileorg=sys.argv[1]

if "objname" in fileorg:
    obj=True
    objname="cell"
else:
    obj=False


fin=open(fileorg,"r")
textOrg=fin.read()
fin.close()

m=meta(textOrg)
m.initializeAtoms()
#m.printout()


outtext=""

outtext=buildMainRules(m,outtext)
outtext=outtext+"\n\n"

outtext=postProcessCellElts(outtext)

fout=open(fileorg+"_debug_onlymain","w")
fout.write(outtext)
fout.close()

outtext=buildAbPRules(m,outtext)
outtext=outtext+"\n\n"
outtext=buildAbCRules(m,outtext)

fout=open(fileorg+"_debug","w")
fout.write(outtext)
fout.close()
